; From https://github.com/SamCoVT/FOCAL65_KIM1/blob/main/FOCAL-StartingCompletedSource_v3d_Aresco_V1.txt
;	on Jan 22 2024

; FOCAL-65 (V3D) 26-AUG-77 FOR KIM-1, by Wayne Wall (c) 1977

; First disassembly by Paul R. Santa-Maria (2004)
; Initial comments added by Hans Otten, 2022
;
; New listing and comments from Wayne Wall's FOCAL-65 v3 (6502-TIM monitor ROM)
; and v4 (Apple II-specific) painstakingly typed in by Dave Hassler and
; Nils Andreas, 2023. (WAYNE'S COMMENTS, my/Nils's comments - dhh)
; v3d TIM source provided by Paul Bikle, v4 by Wayne Wall, both in 2023.
; Proofreading and corrections by


	.list on
	.listbytes unlimited ;include all object bytes in listing (since we load the listing file)
	.pc02	;select CPU
	.feature loose_string_term ; used to put quotes in strings
	.feature string_escapes
	.feature org_per_seg


; .zeropage ; ; ZERO PAGE USE:
	.org 0

; Saved zero page contents
;0000  53 53 4C E0 2C 4C DF 2C-00 00 00 00 00 00 00 00
;0010  00 62 7B 66 EB 6B 3A 7B-6A 6B 6B 7B FB 7B 6B 6B
;0020  00 00 00 00 00 00 FF 00-00 01 00 00 00 00 00 E0
;0030  36 FE 36 00 00 00 00 00-00 00 00 00 00 00 FF 36
;0040  FF 36 FF 36 00 00 00 00-00 00 00 00 00 00 00 00
;0050  00 00 00 00 5F 00 00 00-00 00 00 00 00 00 4C 00
;0060  00 6C 00 00 48 00 00 00-00 00 00 00 00 00 00 C0
;0070  10 00 00 00 00 00 00 00-00 00 00 00 00 00 00 00
;0080  00 00 00 00 00 00 00 00-00 00 00 00 00 00 00 05
;0090  05 83 50 00 00 00 7F 40-00 00 00 80 40 00 00 00
;00A0  00 00 00 00 00 FF 1C 3C-7C 5F 7F 7C 3E 7F 3E FF
;00B0  94 DD 84 D4 85 D4 95 04-DD 94 95 DF 8C 15 1D 94
;00C0  00 D3 E0 C1 80 90 D3 C0-C2 A3 00 C0 81 82 C3 80
;00D0  62 6A FB 6B 6A 6A 02 FF-5A 4B E3 10 EB 62 62 4B
;00E0  7F 6C 7F 7D 3F 7F 2E 7F-7F 7E 7F 36 5F 7E 3E 7F
;00F0  94 00 FF FF 84 A7 19 83-00 00 DF 10 A9 FF C7 01


	.res 2	;$00	= unused
	.res 3 ; JMP IntSrv ;$02 unused
	.res 3 ; JMP NmiSrv ;$05 unused

	.res 8	;$08
	.res 8	;$10 unused
	.res 8	;$18 unused

DebgSw:	.res 1	;$20	; TRACE FLAG
DmpSw:	.res 1	;$21	; DUMP SWITCH
ATSW:		.res 1	;$22	; ASK-TYPE CMDS FLAG
IFONSW:	.res 1	;$23	; IF-ON CMDS FLAG
INSW:		.res 1	;$24	; INPUT INDICATOR
MSChar:	.res 1	;$25	; 'MODIFY' SEARCH CHAR

		; *** FOLLOWING MUST BE CONTIGUOUS ***
PC:		.res 2 ;$26	; PROG COUNTER (grp, line)
			;   grp=0 means direct line
TxtAdr:	.res 2 ;$28	; CHAR ADDR
TextP:	.res 1 ;$2A	; TEXT POINTER
CHAR:		.res 1 ;$2B	; CURRENT CHARACTER
GrpNo:	.res 1 ;$2C	; GROUP NUMBER
LineNo:	.res 1 ;$2D	; LINE (STEP) NUMBER
PriLvl:	.res 1 ;$2E	; CURRENT S/W INTERUPT PRIORITY
		; *** END OF MUST BE CONTIGUOUS ***

TxtBeg:	.word Prog0 ;$2F	; POINTER TO BEGINNING OF STORED PROGRAM  constant
PBADR:	.word Prog1 ;$31	; ADDR OF Start OF USER PROGRAM
TxtAd2:	.res 2 ;$33
TextP2:	.res 2 ;$35		; COUNTERPART TO 'CHAR,' ABOVE

		; POINTERS TO VARIABLE LIST - *** MUST BE CONTIGUOUS ***

VarAdr:	.res 2 ;$37		; POINTER TO CURRENT VAR IN LIST
VSub:	.res 2 ;$39		; LOCATION TO HOLD SUBSCRIPT DURING VAR SEARCH
FSwit:
StrSwt:	.res 1 ;$3B		; FLAG IF CURR VAR IS $ (also label FSwit)
VSize:	.res 1 ;$3C		; SIZE OF CURR STRING VAR (GetVar)
VCHAR:	.res 1 ;$3D		; PLACE TO HOLD VAR NAME DURING SEARCH (also TCHAR)
VarBeg:	.word Variable0 ;$3E	; POINTER BEGINNING VAR LIST
VarSt:	.word Variable0 ;$40	; POINTS TO start of vars after 'E ALL' command (constant)
VarEnd:	.res 2 ;$42	; POINTS TO END OF VAR LIST (write only?)

		; POINTERS FOR STRING I/O

StIAdr:	.res 2 ;$44		; HOLDS ADDR POINTER TO INPUT STRING
StIPnt:	.res 1 ;$46		; OFFSET POINTER
StIMax:	.res 1 ;$47		; HOLDS SIZE OF INPUT STRING
StOAdr:	.res 2 ;$48		; HOLDS ADDR POINTER TO OUTPUT STRING
StOPnt:	.res 1 ;$4A		; OFFSET POINTER
StOMax:	.res 1 ;$4B		; HOLDS SIZE OF OUTPUT STRING

		; SOFTWARE PushDoWN LIST

PdpAdr:	.res 2 ;$4C		; current page (see PdList)
PDP:		.res 1 ;$4E		; offset in (PdpAdr)
PdpTmpz:	.res 2 ;$4F		; TEMP LOC. FOR 'ROOMCK' (unused)

TGrp:		;$51		; HOLDS TEMPORARY GROUP NUMBER FOR SOME
TLine:	.res 2 ;$51		;   OPERATIONS. TEMP LINE # HERE (write only?)

PdList:	.word RamLastPage ;$53	; StartING ADDR OF SOFTWARE PDL (stack) (constant)
			; ** effectively, the last page of FOCAL's user RAM.
			;    Change to what suits your system. - dhh

StrAd1:
StrCnt:
ITmp1L:	.res 2 ;$55		; Temp1 LOW BYTE
ITmp1H	= ITmp1L+1		; Temp1 HIGH BYTE
SBeg1:	.res 1 ;$57		; Start POS. OF STRING 1
SEnd1:	.res 1 ;$58		; END POS. STRING 1
StrAd2:
StrMax:
ITmp2L:	.res 2	;$59		; TEMP2 LOW BYTE
ITmp2H	= ITmp2L+1		; TEMP2 HIGH BYTE
SBeg2:	.res 1	;$5B		; Start POS. OF STRING 2
SEnd2:	.res 1 ;$5C		; END POS. STRING 2

STBSAV:	.res 1	;$5D		; PLACE TO SAVE BEGINNING SUBSCRIPT
JsrInd:	.byte $4c ;$5E		; JSR OPCODE ($4C) FOR 'JsrInd' - *MUST* BE PLACED JUST BEFORE 'Temp1'.  constant
Temp1:	.res 2	;$5F		;   NOT NECESSARILY PRESERVED ACROSS SUBROUTINE CALLS!
JmpIndz: .res 3 ;jmp (0) ;$61	; OPCODE FOR 'JMP INDIRECT' ($6C)  constant unused
;PJmpL  = JmpInd+1 ;$62	; LOW ORDER ADDR  unused
;PJmpH  = JmpInd+2 ;$63	; HIGH ORDER BYTE  unused

StrSiz:	.byte 72 ;$64		; HOLDS DEFAULT STRING SIZE ($48)
ETemp1:	.res 1 ;$65		; TEMP USED BY 'EVAL'
IDev:	.byte 0 ;$66		; SPECIFIES INPUT DEVICE
ODev:	.byte 0 ;$67		; SPECIFIES OUTPUT DEVICE
IDvSav:	.res 1 ;$68		; SAVE INP DEV #
ODvSav:	.res 1 ;$69		; SAVE OUTPUT DEV #
ConDev:	.byte 0 ;$6A		; SPECIFIES DEVICE # OF CONSOLE
EchFlg:	.byte 0 ;$6B		; ECHO FLAG
DelSpl:	.byte 1 ;$6C		; 0=TTY rubout, else CRT rubout
ActMsk:	.res 1 ;$6D		; MASK TO INDICATE WHICH S/W INTERRUPT CH ARE ACTIVE
EvMask:	.res 1 ;$6E		; HOLDS EVENT BITS SET BY EXTERNAL ROUTINES WHEN THEY WANT FOCAL'S ATTENTION
BITV1:	.byte $c0 ;$6F		; USED TO SET V=1, N=1 ($C0) constant
MskBrk:	.byte $10 ;$70		; BIT TEST MASK FOR BREAK ($10) constant
ACSAV:	.res 1 ;$71		; PLACE WHERE ACC IS SAVED ON INTERRUPT
STATUS:	.res 1 ;$72		; PLACE WHERE PROC STATUS IS SAVED ON INTERRUPT
ITemp1:	.res 2	;$73		; PLACE WHERE RET ADDR IS KEPT ON INTERRUPT

LastOp:	.res 1 ;$75		; USED BY 'EVAL'

Hash:		.res 1 ;$76		; system randomized value
			;   *** NOTE: SOME ROUTINE IN YOUR SPECIFIC
			;	      COMPUTER SYSTEM SHOULD LOAD THIS
			;	      LOC. WITH A PSEUDO-RANDOM 8-BIT VALUE.
SEED:	.res 3 ;$77		; 3 BYTES. HOLDS A 23-BIT RANDOM # SEED - SEE 'FRan'

		; Floatint Point routines Z Page use

SIGN:	.byte 0 ;$7A		;

FAc2:
X2:	.res 1 ;$7B		; FAc2 EXPONENT
M2:	.res 4 ;$7C		; FAc2 MANTISSA

FAc1:
X1:	.res 1 ;$80		; FAc1 EXPONENT
;FLCSGN:
M1:	.res 4 ;$81		; FAc1 MANTISSA

E:	.res 5 ;$85		; SCRATCH AREA (must follow M1)

		; FloatING POINT I/O ROUTINES

SIGNP:	.res 1 ;$8A		; TEMPORARY SIGN
DpFlg:	.res 1 ;$8B		; SAW DECIMAL POINT
GotFlg:	.res 1 ;$8C		; IF NON ZERO, WE ACTUALLY INPUT A NUMBER
K:	.res 1 ;$8D		; MISC COUNTER
L:	.res 1 ;$8E		; TEMP
M:	.byte 5 ;$8F		; # OF PLACES BEFORE DECIMAL POINT
N:	.byte 5 ;$90		; # OF PLACES AFTER DECIMAL POINT

FTen:	.byte $83,$50,0,0,0 ;$91 ; CONSTANT 10
FHalf: .byte $7F,$40,0,0,0 ;$96 ; CONSTANT 0.5
FOne:	.byte $80,$40,0,0,0 ;$9B ; CONSTANT 1

T:	.res 5 ;$A0		; TEMP (5 bytes)



		; FLAG END OF OUR PAGE ZERO USAGE
		; FOR ANYONE WHO NEEDS TO KNOW

;	$A5 = SAVYR  save for Y register (was $7F in v3 - RUBOUT)
;	also, end of zero page usage
;	TIM I/O package not in the Aresco version of v3d.




		;		FOCAL SYMBOL DEFINITIONS
		;
		; ALL POSSIBLE SYMBOLIC EQUATES SHOULD BE KEPT IN THIS MODULE


		; FOCAL ERROR CODES - NEGATIVE

BASTRF	= $DB	; -37 BAD OR MISSING ARGUMENT IN A STRING FUNCTION
SVRQ	= $DC	; -36 STRING VARIABLE REQUIRED HERE
SVNA	= $DD	; -35 STRING VARIABLE NOT ALLOWED HERE
ERRO	= $DE	; -34 I-O ERROR ON OUTPUT DEVICE
ARGM	= $DF	; -33 ARGUMENT MISSING IN FUNCTION
XNU32	= $E0	; -32 CURRENTLY NOT USED
WNEXG	= $E1	; -31 "WRITE" OF NON-EXISTANT GROUP
UnrFun	= $E2	; -30 UNRECOGNIZABLE FUNCTION NAME
PFERR	= $E3	; -29 PARENTHESES ERROR IN FUNCTION
MNEXL	= $E4	; -28 "MODIFY" OF NON-EXISTANT LINE
DoNExG	= $E5	; -27 "DO" OF NON-EXISTANT GROUP
DONEXL	= $E6	; -26 "DO" OF NON-EXISTANT LINE
IFSYN	= $E7	; -25 SYNTAX ERROR IN "IF" OR "ON" COMMAND
ENEXL	= $E8	; -24 "ERASE" OF NON-EXISTANT LINE
ERRI	= $E9	; -23 I-O ERROR ON INPUT DEVICE
WNEXL	= $EA	; -22 "WRITE" OF NON-EXISTANT LINE
GONEXL	= $EB	; -21 "GOTO" NON-EXISTANT LINE
BadLi	= $EC	; -20 BAD LINE NUMBER ON INPUT
UnkInt	= $ED	; -19 UNKNOWN INTERRUPT REQUEST
UnrBrk	= $EE	; -18 UNRECOGNIZABLE TRAP CODE
ResBrk	= $EF	; -17 RESET BUTTON PRESSED
DEVRNG	= $F0	; -16 DEVICE NUMBER OUT OF RANGE
UFL	= $F1	; -15 USELESS "FOR" LOOP
FBDTRM	= $F2	; -14 BAD TERMINATOR IN "FOR"
NOEQLS	= $F3	; -13 NO "=" IN "FOR"
BadVar	= $F4	; -12 BAD VARIABLE NAME
FunIll	= $F5	; -11 FUNCTION ILLEGAL HERE
XNU10	= $F6	; -10 NOT USED AT THIS TIME
XNU9	= $F7	; -9 NOT USED AT THIS TIME
FOVFL	= $F8	; -8 FloatING POINT OVERFLOW
OPNMIS	= $F9	; -7 OPERAND MISSING - EVAL
PMATCH	= $FA	; -6 PARENTHESES MISMATCH - EVAL
OPRMIS	= $FB	; -5 OPERATOR MISSING - EVAL
ILLNO	= $FC	; -4 ILLEGAL LINE NUMBER
BADCOM	= $FD	; -3 UNRECOGNIZABLE COMMAND
EILLG0	= $FE	; -2 ILLEGAL GROUP ZERO USAGE
LTL	= $FF	; -1 LINE TOO LONG


		; MORE DEFINITIONS

NumbF	= 5		; # BYTES IN A F.P. #
VarSiz	= 3+NumbF	; 1 BYTE FOR NAME, 2 BYTES SUBSCRIPT, THEN VALUE
LineL	= 127		; MAX LENGTH FOCAL LINE +1; MUST NOT >127 (SEE 'PackC')
EOV	= $FF		; END OF VAR MARKER
EOP	= $FE		; END OF PROG MARKER
UMark	= $FD		; ANOTHER UNIQUE MARKER
StrMrk	= $FC		; MARKS A STRING VAR IN VAR LIST
;StrLen	= 72		; DEF STRING LENGTH (see StrSiz) unused

RubChr	= $5C	; '\' ECHOED FOR RUBOUT (unused here for modern tty emu)
LinChr	= '_'	; ECHOED FOR LINE DELETE
AltChr	= $1B	; 'ESC' CHAR USED FOR 'ALTMODE' - MAY REQUIRE CHANGE

;DirLin	= $FF
StrLin	= $FE
RetCmd	= $FD

RStack	= $0100	; 6502 return stack
;ComBuf:  ; Command line buffer starts here (bottom of stack page)

 .macro Trap ErrNum  ; build error trap
	brk			; with no 2nd byte
	  .byte ErrNum	; the 2nd byte contains the error code
   .endmacro

; self modifying code locations: (P.R.S-M)
;  Search for "modified"
;		 H2350	 EQU $2350
;		 H2351	 EQU $2351
;		 H282F	 EQU $282F
;		 H2830	 EQU $2830
;		 H340A	 EQU $340A
;		 H340C	 EQU $340C

;  .code
  .org $2000

;			***** 'FOCINT - FOCAL CODE INTERPRETER
;
;		THIS IS WHERE THE HEART OF FOCAL LIES.	INPUT ProcesSING,
;	COMMAND DECODING, CONTROL FLOW, AND EXECUTION ARE PERFORMED
;	IN THIS MODULE.
;

FOCAL: ; COMES HERE ON A 'RESET' (PANIC REStart)

	SEI		; MAKE SURE INTERRUPTS ARE DISABLED
	CLD		; AND DECIMAL MODE IS OFF
	LDX #$FF	; INIT STACK POINTER
	TXS
	JSR Setup	; SET UP SOME INITIAL PARAMETERS
	JSR InIDev	; INIT CONSOLE DEVICE
	Trap ResBrk	; ENTER FOCAL VIA TRAP (INDICATE 'RESET' PRESSED)


Setup:	LDX #$FF	; INIT SOFTWARE PushDoWN LIST
	JSR PdpIni
	INX		; FORM A ZERO IN X
	STX EchFlg	; TURNS ECHOING ON

ClrDev:	LDA ConDev	; SET CONSOLE AS BOTH IN AND OUT DEVICES
	STA IDev
	STA ODev
	RTS


PdpIni: ; Init software pushdown stack
	STX PDP		; ASSUMED TO CONTAIN '$FF' IN X REGISTER
	LDA PdList+0	; RESET ADDR POINTER
	STA PdpAdr+0
	LDA PdList+1
	STA PdpAdr+1
	RTS


InIDev: ; INIT I/O DEVICES
	LDA IDev	; INIT INPUT DEVICE
	JSR INI
	LDA ODev	; INIT OUTPUT DEVICE
	JMP INO		; * PJMP * AND RETURN


QUIT:			; command processor
Start: ; warm entry point. FOCAL comes here on an internal restart.
	LDX #$FF
	TXS		; INIT STACK
	STX DmpSw	; FLAG THE TRACE OFF
	STX PC+0	; INDICATE PROC. A DIRECT COMMAND
	INX		; GET A ZERO
	STX DebgSw	; ALLOW TRACE TO BE ENABLED
	STX TxtAdr+0	; INIT TEXT POINTERS TO ComBuf
	STX TextP	; RESET OFFSET POINTER TO TEXT LINE
	STX ActMsk	; INDICATE ALL S/W INTER. CHNLS INACTIVE
	STX EvMask	; CLEAR ANY EXT. EVENT FLAGS
	STX PriLvl	; SET TO LOWEST PRIORITY LEVEL
	INX		; GET A 1
	STX TxtAdr+1	; ComBuf IS IN STACK AREA
	LDA #'*'	; ANNOUNCE OUR PRESENCE
	JSR PrintC
@NextIC: JSR ReadC	; INPUT A CHAR FROM INPUT DEVICE
	CMP #$0A	; LF?
	BEQ @NextIC	;   IGNORE LF ON COMMAND INPUT
	JSR PackC1	; STORE CHAR IN CMD BUFFER
	CMP #$0D	; CR?
	BNE @NextIC	;   IF NOT, GET ANOTHER

 ; COMMAND/INPUT Processor
	LDX #0		; RESET TEXT POINTER
	STX TextP
	STX INSW	; FLAG TEXT CHAR TO COME FROM MEMORY
	DEX		; SET TO $FF
	JSR PdpIni	; INIT SOFTWARE PDL POINTER
	JSR GSPNOR	; IGNORE LEADING BLANKS
	JSR TestN1	; HAVE A NUMBER?
	BCC @GotNum	;   YES, BRANCH
	CMP #'.'	; TEST '.'
	BNE INPX1	;   NOT # OR '.', MUST BE DIRECT CMD
	Trap EILLG0	; ILL. GROUP 0 USEAGE

@GotNum: ; looks like a line #
	INC DebgSw	; DISABLE TRACE FOR PACKING
	JSR GetLnC	; GET THE LINE # FROM ComBuf
	BVS IBadL	; 00.00 IS A BAD LINE NUMBER
	BEQ IBadL	; GG.00 IS A BAD LINE NUMBER
RepLin:	JSR INSERT	; GO INSERT THIS LINE IN THE TEXT AREA
	JMP Start	; AND Start OVER FOR NEXT DIR. CMD

IBadL:	Trap BadLi	; ?BAD LINE # ON INPUT

INPX1:	JSR PushJ	; ProcesS COMMAND
	  .WORD PROC	; $2302
	LDA PC+0	; GET PROGRAM LINE NUMBER
	BMI Start	; Start OVER IF DIRECT CMD
	JSR EatCr1	; EAT TO END OF LINE
	JSR NxtLin	; GO SET UP POINTERS TO NEXT LINE
	BCS INPX1	; BRANCH IF MORE TO DO
	BCC Start	; BRANCH IF END OF PROGRAM


DoStr: ; 'DO' CODE STORED IN A STRING
  ;
  ; THIS ROUTINE ALLOWS THE EXECUTION OF CODE STORED IN A
  ; STRING VARIABLE.  IF ONE PLACES CHARACTERS INTO A STRING
  ; VARIABLE, AND ENDS THEM WITH A CARRIAGE RETURN, THEN A
  ; 'DO' COMMAND CAN BE USED TO PERFORM THE LINE STORED IN THE
  ; STRING VARIABLE.
  ;
	JSR PushDo	; SAVE CURRENT GOODIES ON STACK
	LDA VarAdr+0	; POINT TO SPEC. CHAR IN STRING
	STA TxtAdr+0	;   WITH TEXT POINTERS
	LDA VarAdr+1
	STA TxtAdr+1
	LDA VSub+1	; GET CHAR POSITION IN STRING
	STA TextP
	LDA #StrLin	; FLAG THIS SO 'FNDLIN' WILL ALWAYS Look
	STA PC+0	;   FROM BEGINNING OF PROGRAM TEXT
	LDA VCHAR	; STORE THE STRING VARIABLE'S NAME FOR
	STA PC+1	;   ERROR MSG PRINT ROUTINE (BError)
	JSR PushJ	; NOW 'DO' THE STRING (SHUD HAVE CR!)
	  .WORD Proces	; $22FF
	JSR PopDo	; RESTORE CURRENT GOODIES
	JSR PopJ	;   AND RETURN FROM 'DO'


PushDo: ; Push execution point detail.	 USED BY 'DO'
	; PC TxtAdr TextP CHAR GrpNo LineNo PriLvl
	LDX #PC		; GET ADDR OF Start OF SAVE AREA
	LDY #PriLvl-PC+1 ;   AND # OF BYTES TO SAVE
	JMP PushB0	; * PJMP * PUSH THEM ON STACK & RET.
	.assert PC    <TxtAdr, error, "order?"
	.assert TxtAdr<TextP , error, "order?"
	.assert TextP <CHAR  , error, "order?"
	.assert CHAR  <GrpNo , error, "order?"
	.assert GrpNo <LineNo, error, "order?"
	.assert LineNo<PriLvl, error, "order?"


PopDo: ; Pop execution point detail.  USED BY 'DO'
	LDX #PriLvl	; get addr of end of save area
	LDY #PriLvl-PC+1 ;   AND # OF BYTES TO RESTORE
	JMP PopB0	; * PJMP * POP THEM OFF AND RETURN



IF:	; BOTH COMMANDS HAVE COMMON ENTRY POINT
ON: ; 'IF' COMMAND Processor (CONDITIONAL GOTO)

; in WW source of '77, JSR PushA is here; not in Aresco binary --dhh
;
	STA IFONSW	; not in Aresco code
	JSR GSPNOR	; MOVE TO NEXT NON-BLANK
	CMP #'('
	BEQ @CNT1	; YES, BRANCH
	Trap IFSYN	; SYNTAX ERROR IN 'IF' OR 'ON' CMD (IFSYN)

@CNT1:	JSR PushJ	; NOW EVALUATE WHAT'S IN PARENS
	  .WORD EvalM1
	LDA CHAR	; GET TERMINATOR
	CMP #')'
	BEQ @CNT2	; YES, CONTINUE
	Trap PMATCH	; ?PARENTHESIS MISMATCH

@CNT2:	JSR GetC	; MOVE PAST RIGHT PAREN
	LDA M1+0	; GET THE SIGN OF THE EXPRESSION
	BMI @XCT	; IF NEGATIVE, GO DO IT NOW
	BPL @3		; OTHERWISE, Look FOR COMMA
@COM:	JSR GetC	; GET A CHAR
@3:	LDA CHAR
	CMP #','
	BEQ @1		; BRANCH IF YES
	CMP #';'
	BEQ @NOP	; YES, CONTINUE WITH NEXT CMD ON THIS LINE
	CMP #$0D	; CR?
	BNE @COM	; NO, KEEP LookING ('JSR PopA' in betw. orig)
	JSR PopJ	; YES, THEN EXIT 'ProcesS'
@1:	JSR GetC	; MOVE PAST THE COMMA
	LDA #0		;	   from here, the Aresco code is wildly
	LDX #3		; different from the original Program Exchange.	 ...
@2103:	ORA M1,X	; (left generic label from disassembly here)
	DEX		;
	BPL @2103	;
	ORA #0		; ... to here.	--dhh
	BEQ @XCT	; BRANCH IF FAc1=0
	JSR ZrFAc1	; SET IT TO ZERO, THIS TIME FOR SURE
	BMI @3		; UNCONDITIONAL BRANCH

@XCT:	JSR GetLnS	; GO GET THE LINE NUMBER
	PHP		; SAVE ProcesSOR FLAGS
	JSR EatECM	; EAT UNTIL THE END OF A COMMAND
	PLP		; GET FLAGS BACK
	BVS @NOP	; BRANCH IF NO LINE NUMBER GIVEN
	PHP		; SAVE THEM AGAIN
	LDA IFONSW	; is 'JSR PopA' in orig.
	CMP #'O'
	BEQ @Do1	;   YES, GO 'DO' THE LINE
	PLP		; ADJUST STACK
	JMP GOTO1	; 'IF' CMD, THEN 'GOTO' LINE

@NOP:	JMP PROC	; ADJUST STACK (then 'JMP PROC' in orig...)

@Do1:	PLA		; GET STATUS SAVED AFTER 'GetLn' CALL
	TAX		; SAVE IN THE X REGISTER
	JSR PushJ	; NOW PERFORM THE 'DO' OF THE LINE OR GROUP
	  .WORD Do1	; $21B6
	JMP PROC	; AND THEN CONTINUE ProcesSING ON THIS LINE


MODIFY: ; MODIFY CMD Processor: 'MODIFY' A LINE OF THE USER'S PROGRAM
	JSR GetLnS	; GET THE LINE NUMBER SPECIFIED
	BVS @Bad	; BRANCH IF 00.00
	BNE @NOK	; BRANCH IF GG.LL
@Bad:	Trap MNEXL	; ?MODIFY OF NON-EXISTANT LINE ($E4)

@NOK:	JSR FindLn	; TRY TO FIND THE LINE
	BCC @Bad	; BRANCH IF COULD NOT FIND
	JSR CRLF	; OUTPUT A BLANK LINE
	JSR PrntLn	; PRINT THE LINE NUMBER
	LDY #2		; SET OFFSET TO FIRST CHAR ON LINE
	STY TextP2
	LDA #0 ;<ComBuf
	STA TxtAdr+0	; INIT POINTERS TO ComBuf
	STA TextP
	LDA #1 ;>ComBuf
	STA TxtAdr+1
@NxtC:	JSR RNoEch	; GO WAIT FOR THE GUY TO TYPE A CHAR
	CMP #$0A	; LINE FEED?
	BEQ @Look1	;   YES, THEN GO FEED TO END OF LINE
	CMP #AltChr	; ALTMODE?
	BEQ @Look	;   YES, THEN PICK UP SEARCH CHAR
	CMP #$7f	; RUBOUT
	BEQ @NoEch	;   YES, THEN DON'T ECHO
	CMP #LinChr	; 'LINE-DELETE' CHAR?
	BEQ @NoEch	;   BRANCH IF IT IS, DO NOT ECHO
	JSR PrintC	; ECHO THE CHARACTER
@NoEch:	JSR PackC1	; PACK CHAR INTO ComBuf
	CMP #$0D	; WAS CHAR A CARRIAGE RETURN?
	BNE @NxtC	;   NO, THEN PICK UP NEXT CNE
@EndL:	JSR OutLf	; FOLLOW WITH A LINE FEED
	LDA #1		; SET ComBuf OFFSET
	STA TextP	; FOR 'INSERT'
	INC DebgSw	; DISABLE TRACE FOR INSERT
	JMP RepLin	; AND GO REPLACE OLD LINE WITH EDITED LINE

@Look:	JSR RNoEch	; SILENTLY GET THE SEARCH CHAR
@Look1:	STA MSChar	; STORE SEARCH CHAR
@Look2: LDY TextP2	; GET POINTER TO TEXT IN MEMORY
	LDA (TxtAd2),Y	; GET CHAR
	INY		; POINT TO NEXT
	STY TextP2	;
	JSR PackC1	; PACK THE CHAR
	JSR PrintC	; ECHO IT
	CMP MSChar	; WAS IT THE SEARCH CHAR?
	BEQ @NxtC	; BRANCH IF YES
	CMP #$0D	; CR?
	BEQ @EndL	;   YES, THEN THAT'S IT
	BNE @Look2	; NO, THEN KEEP Looking


DO: ; 'DO' RECURSIVE OPERATE, EXECUTE, OR CALL
	JSR PushJ	; CALL THE 'DO' SUBROUTINE
	  .WORD @X	; $21A2
	JMP PROC	; AND CONTINUE ProcesSING

@X:	LDA #0		; ZERO OUT THE STRING VARIABLE SWITCH
	STA StrSwt
	JSR GetLnS	; GO GET THE LINE NUMBER TO 'DO'
	PHP		; SAVE FLAGS FROM 'GetLnS'
	LDA StrSwt	; WAS EXPRESSION A STRING VARIABLE?
	BEQ @X1		; BRANCH IF NOT, PRESS ON
	PLP		; YES, THEN ADJUST STACK
	JMP DoStr	; * PJMP * DO CODE STORED IN STRING, RET

@X1:	PLP		; RESTORE FLAGS FROM 'GetLnS'
	JMP DO2		;   AND ENTER ROUTINE

Do1:	TXA		; ENTER HERE WITH STATUS FROM 'GetLn' IN X
	PHA		; SAVE ON STACK
	PLP		; MAKE CURRENT ProcesSOR STATUS
DO2:	PHP		; SAVE ProcesSOR STATUS ACROSS THE SAVE
	JSR PushDo	; SAVE IMPORTANT STUFF ON STACK FOR LATER
	PLP		; GET THE FLAGS BACK
	BVS DoGrp	; BRANCH IF "DO ALL"
	BEQ DoGrp	; OR "DO" IS A GROUP
DoOne:	JSR FindLn	; TRY TO FIND THE LINE TO "DO"
	BCS @CNT1	; BRANCH IF WE FOUND IT
	Trap DONEXL	; ?"DO" OF NON-EXISTANT LINE (#$E6)

@CNT1:	JSR NewLin	; SET UP THE NEW LINE
	JSR PushJ	; AND EXECUTE IT
	  .WORD Proces	; $22FF
DoCont:	JSR PopDo	; NOW RESTORE IMPORTANT STUFF AS IT WAS
	JSR PopJ	; AND RETURN

DoGrp: ; 'DO' COMMAND ProcesSOR
	JSR FindLn	; TRY TO LOCATE SMALLEST LINE OF THE GRP
	LDA TGrp	; IS IT THE SAME GRP WE'RE LookING FOR?
	CMP GrpNo
	BEQ @1		; BRANCH IF YES
	Trap DoNExG	; ?"DO" OF NON-EXISTANT GROUP (#$E5)

@1:	LDA TGrp	; GET THE GROUP NUMBER WE ARE 'DO'ING
	JSR PushA	; SAVE ON STACK
@C:	JSR NxtLin	; SET UP POINTERS FOR NEXT LINE
	BCC @END	; BRANCH IF END OF PROGRAM
	JSR PopA	; GET GROUP NUMBER WE ARE 'DO'ING
	JSR PushA	; SAVE IT AGAIN
	ORA #0		; ARE WE DOING GROUP ZERO (ALL)?
	BEQ @Next	; YES, THEN ANY LINE IS OK
	CMP PC		; IS THIS LINE OF THE SAME GROUP?
	BNE @END	; BRANCH IF NOT
@Next:	JSR PushJ	; YES, THEN ProcesS THIS LINE
	  .WORD Proces	; $22FF
	JSR EatCr1	; EAT UNTIL A CARRIAGE RETURN
	LDA PC		; GET THE CURRENT LINE NUMBER
	CMP #RetCmd	; 'RETURN' COMMAND SEEN?
	BNE @C		; BRANCH IF NOT, CONTINUE
@END:	JSR PopA	; ADJUST STACK
	JMP DoCont	; AND RETURN FROM "DO"


RETURN: ; "RETURN" AND "RESTORE" COMMANDS
	JSR SPNOR	; GET NEXT NON-BLANK
	CMP #'I'	; IS THIS A 'RESTORE INPUT' (R I)?
	BEQ @Inp
	CMP #'O'	; IS THIS A 'RESTORE OUTPUT' (R O)?
	BEQ @Out
	LDA #RetCmd	; IT MUST BE A "RETURN"
	STA PC+0	; SET PC TO SPECIAL VALUE
	JSR PopJ	; AND EXIT "ProcesS"

@Inp:	LDA IDvSav	; RESTORE INPUT DEVICE # TO WHAT IT WAS
	STA IDev	;   BEFORE LAST STRING INPUT
	JMP Proces	;   AND CONTINUE EXECUTING ON THIS LINE

@Out:	LDA ODvSav	; RESTORE OUTPUT DEVICE # TO WHAT IT WAS
	STA ODev	;   BEFORE LAST STRING OUTPUT
	JMP Proces	;   AND CONTINUE EXECUTING ON THIS LINE


ERASE: ; "ERASE" COMMAND ProcesSOR
	JSR SPNOR	; GO GET NEXT NON-BLANK
	LDY #0		; this is not in the 6502 Group/ProgExch
	CMP #'A'	;	source code of 13-Oct-77   --dhh
	BEQ @All	;	occurs later at $225A
	JSR GetLn	; GO GET THE LINE NUMBER TO ERASE
	PHP		; SAVE FLAGS
	JSR PushTP	; SAVE TEXT POINTERS
	PLP		; GET FLAGS BACK
	BVS @Var	; BRANCH IF JUST 'ERASE' WITH NO LINE NO.
	BEQ @Grp	; BRANCH IF WE ERASE A GROUP
	JSR FindLn	; NOW TRY AND LOCATE THE SPECIFIED LINE
	BCS @CONT	; BRANCH IF WE FOUND IT
	Trap ENEXL	; ?ERASE OF NON-EXISTANT LINE (#$E8)

@CONT:	JSR DELETE	; GO ZAP THE LINE
@Don:	JMP Start	; AND GO TO DIRECT COMMAND MODE

@Var:	LDA #EOV	; ERASE ALL THE VARIABLES
	STA (VarBeg),Y	; BY FLAGGING LIST AS EMPTY
	JSR PopTP	; RESTORE TEXT POINTERS
	JMP PROC	; AND CONTINUE ProcesSING THIS LINE

@All: ; erase all of program
	LDA #EOP	; ERASE PROGRAM TEXT, EXCEPT GROUP ZERO
	STA (PBADR),Y
	LDA VarSt+0	; UPDATE VarBeg
	STA VarBeg+0
	LDA VarSt+1
	STA VarBeg+1
	LDA #EOV
	STA (VarBeg),Y	; FLAG VARIABLE LIST AS EMPTY
	BNE @Don	; bra; AND Start OVER

@Line:	JSR DELETE	; DELETE THE LINE
@Grp:	JSR TxtIni	; RESET TEXT POINTER TO Start OF PROGRAM
	JSR FindLn	; TRY TO FIND THE GROUP
	LDA TGrp	; GET GROUP NUMBER OF LINE FOUND
	CMP GrpNo	; IS IT OF THE GROUP WE ARE DELETING?
	BEQ @Line	; BRANCH IF YES, GO DELETE IT
	BNE @Don	; AND RETURN IF ALL LINES IN GRP DELETED


WRITE: ; WRITE CMD ProcesSOR: 'WRITE' OUT PARTS OF THE PROGRAM TEXT

	JSR GetLnS	; GO GET THE GROUP TO WRITE
	PHP		; SAVE CONDITION CODES
	JSR PushTP	; SAVE POSITION ON THIS LINE
	INC DebgSw	; DISABLE TRACE
	PLP		; GET CONDITION CODES AFTER 'GetLn'
	BVS @All	; BRANCH IF 'WRITE ALL'
	BNE @LINE	; BRANCH IF WE WRITE A SINGLE LINE
@GRP:	JSR FindLn	; TRY TO FIND THE GROUP
	LDA TGrp	; GET THE GROUP LOCATED IN MEMORY
	CMP GrpNo	; IS IT THE ONE WE ARE LookING FOR?
	BEQ @Grp1	; BRANCH IF YES
	Trap WNEXG	; ?'WRITE' OF NON-EXISTANT GROUP (#$E1)

@Grp1:	JSR @GRPO	; OUTPUT THE GROUP
@EXIT:	JSR @CRLF	; BLANK LINE
	DEC DebgSw	; ENABLE TRACE AGAIN
	JSR PopTP	; RESTORE TEXT POINTERS
	JMP PROC	;   AND CONTINUE ProcesSING ON THIS LINE

@LINE:	JSR FindLn	; TRY TO FIND THE LINE
	BCS @LINE1	; BRANCH IF WE FOUND IT
	Trap WNEXL	; ?'WRITE' OF NON-EXISTANT LINE (code #$EA)

@LINE1:	JSR @CRLF	; OUTPUT BLANK LINE
	JSR @ONE	; OUTPUT THE SINGLE LINE
	JMP @EXIT	;   THEN EXIT 'WRITE'

@All:	JSR FindLn	; GO FIND GROUP ZERO (ALWAYS WINS)
@All1:	JSR @GRPO	; OUTPUT THIS GROUP
	BEQ @EXIT	; BRANCH IF END OF PROGRAM
	STA TGrp	; MAKE EXIT GROUP THE GROUP TO OUTPUT
	BNE @All1	;    AND GO OUTPUT IT

@GRPO:	JSR @CRLF	; OUTPUT BLANK LINE
@GRPO1:	JSR @ONE	; OUTPUT THIS LINE
	BEQ @EXGRP	; BRANCH IF END OF PROGRAM
	CMP TGrp	; IS GROUP OF NEXT LINE THE SAME?
	BEQ @GRPO1	; BRANCH IF YES
@EXGRP:	RTS		; OTHERWISE RETURN

@ONE:	JSR PrntLn	; OUTPUT THE LINE NUMBER
@ONEC:	JSR GetC	; GET NEXT CHAR
	JSR PrintC	; OUTPUT IT
	CMP #$0D	; WAS IT THE END OF THE LINE?
	BNE @ONEC	; LOOP IF NOT
	LDA ODev	; YES, ARE WE OUTPUTTING TO A STRING?
	BMI @EOL	; BRANCH IF WE ARE, DON'T FOLLOW WITH $0A
	JSR OutLf	; NO, THEN FOLLOW WITH A LINEFEED
@EOL:	JSR EatCr1	; YES, POINT TO NEXT LINE
	LDY TextP	; LOAD Y WITH OFFSET
	LDA (TxtAdr),Y	; PICK OF GRP NUMBER OF NEXT LINE
	CMP #EOP	; COMPARE TO END-OF-PROGRAM FLAG
@RET:	RTS		; RETURN WITH Z=1 IF END OF PROGRAM
			; RETURN WITH Z=0 IF NOT END OF PROGRAM
@CRLF:	LDA ODev	; ARE WE OUTPUTTING TO A STRING?
	BMI @RET	; BRANCH IF WE ARE, DON'T ADVANCE
	JMP CRLF	; * PJMP * ELSE OUTPUT A CRLF AND RETURN


GOTO: ; MAIN CONTROL AND TRANSFER: 'GOTO' COMMAND
	JSR GetLnS	; GO GET THE LINE NUMBER
GOTO1:	JSR FindLn	; NOW GO TRY TO FIND IT
	BCS @CONT	; BRANCH IF WE FOUND IT
	Trap GONEXL	; ?GOTO NON-EXISTANT LINE

@CONT:	JSR NewLin	; GO SET UP THE NEW LINE
			; * PFALL * INTO ProcesS

Proces:	JSR GetC	; GET NEXT CHARACTER
PROC: ; Process next command in line
	LDA CHAR	; JUST IN CASE CALLED FROM ELSEWHERE
	CMP #$0D	; 'CR' END OF LINE?
	BEQ PC1		; IF SO, THEN RETURN
	JSR GLTest	; IS CHAR A TERMINATOR?
	BEQ Proces	; IF SO, IGNORE IT
EvRet:
	LDX PriLvl	; GET CURRENT SOFTWARE INTERRUPT PRIO LVL
	LDA ActMsk	; GET BYTE THAT INDICATES WHICH CHAN ACTIVE
	BEQ @Proc1	; NONE ALLOWED TO HAPPEN, PRESS ON
	AND IntTab,X	; MASK OUT ANY NOT ALLOWED TO HAPPEN
	BEQ @Proc1	; BRANCH IF NONE PENDING, PRESS ON
	AND EvMask	; NOW SEE IF ANY EVENT PENDING ON CHANNEL
	BEQ @Proc1	; BRANCH IF NONE PENDING, PRESS ON
	LDX #8		; WE HAVE AN EVENT TO SERVICE (AT LEAST 1)
@ILOP:	CMP BitTab,X	; FIND HIGHEST PRIORITY ONE TO SERVICE
	BCS EvntDo	; BRANCH WHEN WE HAVE IT
	DEX		; NOT THIS LEVEL, TRY LOWER
	BNE @ILOP	;   AND LOOP UNTIL WE FIND IT
			; *** SHOULD NEVER FALL OUT THIS END! ***

@Proc1:	LDA CHAR	; GET CHARACTER WHICH Started COMMAND
			;	   handwritten note here in ProgExch code:
			;		  " --* JMP EXIT"
	PHA		; TEMPORARILY SAVE COMMAND CHARACTER
@TERM1:	JSR GLTest	; TERMINATOR?
	BEQ @TERM2	; BRANCH IF YES
	JSR GetC	; OTHERWISE, SKIP OVER REST OF COMMAND NAME
	BPL @TERM1	; UNCONDITIONAL BRANCH

@TERM2:	PLA		; GET 1ST CHAR OF CMD NAME BACK AGAIN
	LDX #0		; INIT TABLE OFFSET TO ZERO
@Nxt:	LDY ComTab,X	; end of table?
	BEQ IllCom
	CMP ComTab,X	; match?
	BEQ @Got
	INX		; NO, POINT TO NEXT ONE
	BNE @Nxt	; UNCONDITIONAL LOOP FOR NEXT ONE

@Got:	LDY ComAdL,X	; GET LOW ORDER ADDR OF ROUTINE
	STY @J+1	; SAVE IN DUMMY JUMP (below)
	LDY ComAdH,X	; GET HIGH ORDER ADDR OF ROUTINE
	STY @J+2	; SAVE IN DUMMY JUMP (next)
@J:	JMP 0		; DISPATCH TO COMMAND ROUTINE  modified


GLTest: ; EXITS WITH Z SET IF CHARACTER IN THE ACCUMULATOR
	; IS A TERMINATOR (SPACE, COMMA, OR SEMI-COLON).
	CMP #$20	; SPACE?
	BEQ Rts2
	CMP #','	; COMMA?
	BEQ Rts2
TstEoc:	CMP #';'	; SEMI-COLON?
	BEQ Rts2
	CMP #$0D	; CARRIAGE RETURN?
Rts2:	RTS		; RETURN WITH Z=1 IF ANY OF THESE

IllCom:	Trap BADCOM	; ?UNRECOGNIZABLE COMMAND

PC1: ; end of "PROC"
	JSR PopJ	; EXIT 'ProcesS'


EvntDo: ; PERFORM A 'DO' OF A SPECIFIED LINE OR GROUP
	; WHEN AN EXTERNAL EVENT HAPPENS ON A SOFTWARE INTERRUPT CHANNEL.

	TXA		; SAVE X AS IT HAS LVL OF INTERUPT
	PHA		;   THEN SET UP RETURN ADDR ON STACK
	LDA #<(EvRet-1)	; label EvRet, def. as =PROCX-1
	JSR PushA	; ALA 'PushJ'
	LDA #>(EvRet-1)	; MSB of EvRet address
	JSR PushA
	JSR PushDo	; SAVE IMPORTANT STUFF AT THIS LEVEL
	PLA		; GET NEW PRIO LEVEL OF GRP OR LN TO 'DO'
	TAX
	STX PriLvl	; SET IT AS OUT NEW PRIO LEVEL
	LDA BitTab,X	; GET BIT MASK FOR THIS NEW LEVEL
	EOR #$FF	; COMPLIMENT TO MAKE 'AND' MASK
	PHP		; SAVE STATE OF 'I' BIT IN CASE IRQS ARE ON
	SEI		; DISABLE IRQ GRANTING
	AND EvMask	;   WHILE WE UPDATE EVENT MASK
	STA EvMask
	PLP		; WE CAN ALLOW IRQS AGAIN (IF ON)
	LDA IntGrp,X	; GET THE GROUP NUMBER TO 'DO'
	STA GrpNo
	LDA IntLin,X	;   AND THE LINE NUMBER
	STA LineNo
	JSR GotLnO	; NOW SET FLAGS TO DETERMINE WHAT TO 'DO'
	BVS @All	; BRANCH IF WE ARE 'DO'ING ALL
	BEQ @All	;   OR 'DO' OF A GROUP
	JMP DoOne	; *PJMP * 'DO' 1 LINE, RETURN TO 'EvRet'

@All:	JMP DoGrp	; *PJMP * 'DO' A GROUP, RETURN TO 'EvRet'


; 'TYPE & ASK command processor'
;
TDump:	JSR VarIni	; INIT POINTER TO Start OF VARIABLE LIST
TDNext:	JSR CRLF	; Start ON NEW LINE
	LDY #0		; POINT TO VARIABLE NAME
	STY StrSwt	; MAKE SURE STRING SWITCH IS OFF
	LDA (VarAdr),Y	; PICK UP THE VARIABLE NAME
	CMP #EOV	; END OF VARIABLE LIST?
	BEQ JTAsk4
	CMP #StrMrk	; STRING VARIABLE?
	BNE @Cont	;   BRANCH IF NOT
	STA StrSwt	; FLAG IT
	INY		; MOVE PAST MARKER, POINT TO NAME
	LDA (VarAdr),Y	; PICK UP THE NAME
@Cont:	JSR PrtVNm	; PRINT THE VARIABLE'S NAME
	LDA StrSwt	; IS THIS VARIABLE A STRING VARIABLE?
	BNE TPStr	;   BRANCH IF YES, DO SPECIAL OUTPUT
	LDA #'('	; AND THEN Start OF SUBSCRIPT
	JSR PrintC
	LDY #1		; POINT TO SUBSCRIPT
	LDA (VarAdr),Y	; GET HIGH ORDER SUBSCRIPT
	STA M1+0	; SAVE IN FAc1
	INY		; POINT TO LOW ORDER SUBSCRIPT
	LDA (VarAdr),Y	; GET IT
	STA M1+1
	JSR Flt16	; FORM A FloatING POINT NUMBER
	JSR OutLn0	;   AND OUTPUT IT
	LDA #')'	; CLOSING PAREN
	JSR PrintC
	LDA #'='	; PUT IN AN EQUALS FOR FORM
	JSR PrintC
	JSR FetVar	; GET THE VARIABLE'S VALUE INTO FLAC
	JSR FPrnt	; PRINT IT
	JSR NxtVar	; POINT TO NEXT VARIABLE IN THE LIST
	BNE TDNext	; UNCONDITIONALLY LOOP FOR MORE


PrtVNm: ; PRINT OUT A VARIABLE'S NAME
	PHA		; SAVE COMPOSITE FORM
	LSR A		; EXTRACT ALPHA PART
	LSR A
	LSR A
	ORA #$40	; FORM ASCII
	CMP #'F'	; ACTUALLY '&', SINCE 'F' IS ILLEGAL
	BNE @TPNAM	;   NOT SPECIAL, SO PRINT IT
	LDA #'&'	; PRINT A '&' AS SPECIAL VARIB NAME
@TPNAM:	JSR PrintC	;   AND PRINT IT
	PLA		; GET BACK composite
	AND #$07	; EXTRACT NUMBER
	ORA #$30	; FORM ASCII
	JMP PrintC	; * PJMP * PRINT THE VARIB # THEN RETURN

JTAsk4:	JMP TAsk4	; BRANCH AID


TPStr: ; TYPE OUT A STRING VARIABLE
	LDA #'$'	; INDICATE IT'S A STRING VARIABLE
	JSR PrintC
	LDA #'='	; DONT PRINT A SUBSCRIPT ON A $ VARIB
	JSR PrintC
	LDA #$22	; '"' DELIMIT STRING WITH QUOTES
	JSR PrintC
	LDY #2		; POINT TO STRING LENGTH
	LDA (VarAdr),Y	; PICK UP THE STRING LENGTH
	STA VSize	; SAVE IT
	INY		; POINT TO FIRST BYTE OF STRING
	TYA		; NOW UPDATE 'VarAdr' TO BASE ADDR OF $
	JSR UpdVar
	LDY #0		; POINT TO FIRST BYTE OF STRING
@NxtC:	TYA		; SAVE OFFSET
	PHA
	LDA (VarAdr),Y	; GET BYTE FROM STRING
	JSR PrintC	; PRINT THE BYTE
	PLA		; RESTORE POINTER
	TAY
	INY		; POINT TO NEXT BYTE
	CPY VSize	; PRINTED ALL OF STRING YET?
	BNE @NxtC	; BRANCH IF MORE TO PRINT
	TYA		; SKIP OVER STRING BY
	JSR UpdVar	;   UPDATING 'VarAdr'
	LDA #$22	; '"' CLOSE OFF STRING WITH CLOSING QUOTE
	JSR PrintC
	JMP TDNext	; AND DUMP NEXT VARIABLE

JTDump:	JMP TDump	; BRANCH AID


; 'TYPE & ASK command processor'

TAsk1:	JSR PushJ	; GO GET THE VARIABLE
	  .word GetVar
	JSR BomStV	; BOMB OUT IF A $ VARIABLE IS USED IN 'ASK'
	LDA CHAR  	; SAVE DELIMITER
	PHA		;   ON HARDWARE STACK
	INC INSW	; FLAG INPUT FROM KEYBOARD
@Agn:	LDX #VarAdr+0	; SAVE THE VARIABLE'S ADDRESS
	JSR PushB2
	JSR PushJ	; NOW GO GET USER SUPPLIED DATA
	  .WORD EvalM1 ;$2A03

; original source has LDA #$41 / STA ATSW
; with the comment: RESTORE 'ATSW' (SINCE WE MUST BE RECURSIVE!)
; the Aresco version of V3D omits this

	LDX #VarAdr+1	; RESTORE VARIABLE'S ADDRESS
	JSR PopB2
	LDA CHAR	; GET DELIMITER FROM EVAL
	CMP #LinChr	; WAS IT 'LINE-DELETE' CHARACTER?
	BNE @STODAT	; BRANCH IF NOT, STORE VALUE AWAY
	LDA IDev	; YES, IS THE INPUT DEVICE
	CMP ConDev	;   THE CONSOLE?
	BNE @Agn	; BRANCH IF NOT, ASK AGAIN
	JSR CRLF	; YES, ADVANCE A LINE
	BPL @Agn	;   AND ASK AGAIN

@STODAT: JSR PutVar	; PLACE DATA IN VARIABLE
	DEC INSW	; FLAG INPUT FROM CORE AGAIN
	PLA		; GET DELIMITER BACK AGAIN
	STA CHAR
	BPL TAsk	; UNCONDITIONALLY CONTINUE ProcesSING

TForm: ; set format
	JSR GetC	; MOVE PAST '%'
	JSR GetLnS	; GET GG.SS
	LDA GrpNo	; GET GG
	STA M		; SAVE AS NUMBER BEFORE DECIMAL POINT
	LDA LineNo	; GET SS
	STA N		; SAVE AS NUMBER AFTER DECIMAL POINT
	JMP TAsk	;   AND CONTINUE ProcesSING

TYPE:	STA ATSW	; FLAG WHICH ONE IT IS
TAsk:	LDA #0		; ENABLE THE TRACE
	STA DebgSw
	JSR SPNOR	; Look FOR NEXT NON-BLANK
	CMP #'$'	; DUMP OUT THE VARIABLE LIST?
	BEQ JTDump
	CMP #'%'	; FORMAT CONTROL?
	BEQ TForm
	CMP #'!'
	BEQ @TCRLF	; GIVE OUT A CARRIAGE RETURN-LINE FEED
	CMP #'#'
	BEQ @TCR	; CARRIAGE RETURN ONLY
	CMP #$22	; '"'
	BEQ TQuot	; TYPE OUT A QUOTED STRING
	CMP #','
	BEQ TAsk4	; IGNORE IN CASE USER WANTS IT TO Look PRETTY
	CMP #';'	; END OF COMMAND?
	BEQ TPROC
	CMP #$0D	; 'CR' END OF LINE?
	BEQ TPC1
	LDA ATSW	; NOT SPECIAL CHAR, GET COMMAND SWITCH
	CMP #'A'	; WHICH COMMAND ARE WE DOING?
	BEQ TAsk1	;   BRANCH IF 'ASK', AS IT DIFFERS
	JSR PushJ	; CALL 'EVAL' TO EVALUATE THE EXPRESSION
	  .word EVAL ;ASL TextP	; this is likely data, point to 'EVAL'

; original source has LDA #$54 / STA ATSW here,
; with the comment: RESTORE 'ATSW' (SINCE WE MUST BE RECURSIVE!)
; the Aresco version of V3D omits this

	JSR FPrnt	; GO OUTPUT IT
	LDA CHAR	; GET TERMINATOR FROM 'EVAL'
	CMP #')'	; SO "TYPE 3)" DOESN'T DIE!
	BEQ TAsk4	; FLUSH IF WE DON'T LIKE IT
	CMP #'='	; ALSO FLUSH OTHER NASTIES
	BEQ TAsk4
	CMP #'.'
	BEQ TAsk4
	BNE TAsk	; OTHERWISE, CONTINUE ProcesSING

@TCRLF:	JSR CRLF	; OUTPUT A CR FOLLOWED BY A LF
	BPL TAsk4	; UNCONDITIONAL BRANCH

@TCR:	LDA #$0D	; 'CR' OUTPUT A CARRIAGE RETURN
	JSR PrintC
TAsk4:	JSR GetC	; SKIP OVER THIS CHARACTER
	BPL TAsk	; UNCONDITIONALLY CONTINUE ProcesSING

TQuot:	INC DebgSw	; DISABLE TRACE SO LITERAL ONLY PRINTS ONCE
TQuot1:	JSR GetC	; GET NEXT CHAR
	CMP #$22	; '"' CLOSING QUOTE?
	BEQ TAsk4
	CMP #$0D	; 'CR' END OF LINE?
	BEQ TPC1	; BRANCH IF YES (IT TERMINATES STRING)
	JSR PrintC	; OTHERWISE, PRINT THE CHARACTER
	BPL TQuot1	; UNCONDITIONALLY LOOP UNTIL DONE

TPC1:	LDA #0		; ENABLE TRACE JUST IN CASE
	STA DebgSw
FPC1:	JMP PC1		; EXIT 'ProcesS'

TPROC:	JMP Proces	; CONTINUE ProcesSING ON THIS LINE


FOR: ; 'FOR' LOOP ITERATION COMMAND

	JSR PushJ	; GO GET THE VARIABLE
	  .WORD GetVar	; ($2B51)
	LDA CHAR	; GET TERMINATOR
	CMP #'='
	BEQ @2
	Trap NOEQLS	; ?NO '=' IN 'FOR' OR 'SET' (#$F3)

@2:	LDX #VarAdr	; SAVE THE ADDRERSS OF THE VARIABLE
	LDY #5		;   AND ITS PROPERTIES
	JSR PushB0	;   ON STACK
	JSR PushJ	; CALL 'EVAL' TO EVALUATE RIGHT HAND SIDE OF '='
	  .WORD EvalM1	;   ($2A03)
	LDX #VarAdr+4	; GET ADDR OF VARIB BACK AGAIN
	LDY #5
	JSR PopB0
	JSR BomStV	; BOMB OUT IF LOOP COUNTER IS STR. VARIB.
	JSR PutVar	; NOT A STRING, SO STORE INITIAL VALUE
	LDA CHAR	; GET THE EXPRESSION TERMINATOR
	CMP #','
	BEQ FIncr	; BRANCH IF IT'S A 'FOR' COMMAND
BTFOR:	Trap FBDTRM	; ?BAD TERMINATOR IN 'FOR' (#$F2)


SET: ; 'SET' COMMAND

; ProgExch version has 20 84 19	  SET1	 JSR GetC   ;SKIP OVER COMMA
; as first line of this section

	JSR PushJ	; EVALUATE EXPRESSION
	  .WORD EvalM1	; 'EVAL' ($2A03)
	LDA CHAR	; GET TERMINATOR
	CMP #','
	BEQ SET		; LOOP FOR ANOTHER expression.
	JMP PROC	; ALL DONE, CONTINUE ON THIS LINE

; there is a handwritten note here: 'Best cmmd exit points $1304'
; ($2302 in this Aresco version code)


FIncr: ; 'FOR' command has increment parameter

	LDX #VarAdr	; SAVE THE ADDR OF THE LOOP VARIB ON STACK
	JSR PushB2
	JSR PushJ	; GO GET THE INCREMENT
	  .WORD EvalM1	; 'EVAL' ($2A03)
	LDA CHAR	; GET TERMINATOR
	CMP #','	; DID WE GET AN INCREMENT?
	BEQ @LIMIT	; YES, GO GET THE UPPER LIMIT OF LOOP
	CMP #';'	; WAS NO INCREMENT SPECIFIED?
	BEQ @1		; BRANCH IF NO INCREMENT GIVEN
	CMP #$0D	; 'CR' CARRIAGE RETURN?
	BNE BTFOR	; NO, THEN BAD TERMINATOR
	Trap UFL	; ?USELESS 'FOR' LOOP (#$F1)

@1:	LDX #$FB	; push FOne
@FI1C:	LDA FOne+5,X
	JSR PushA
	INX
	BMI @FI1C
	BPL @SHORT	; UNCONDITIONAL BRANCH

@LIMIT:	JSR PhFAc1	; SAVE INCREMENT ON STACK
	JSR PushJ	; NOW EVALUATE THE UPPER LIMIT
	  .WORD EvalM1	;  ($2A03)
@SHORT:	JSR PhFAc1	; SAVE UPPER LIMIT ON STACK AND ENTER LOOP

@Cont: ; FOR command parsed, run loop body

	JSR PushTP	; NOW SAVE THE TEXT POINTERS ON STACK
	LDA PC+0	; SAVE PC ACROSS CALL
	JSR PushA
	JSR PushJ	; NOW EXECUTE THE REST OF THE LINE
	  .WORD Proces	;  ($22FF)
	JSR PopA	; SET PC BACK
	STA ITemp1	; SAVE IT IN TEMPORARY
	JSR PopTP	; SAVE POINTERS FOR POSSIBLE RE-ENTRY
	JSR PlTmp	; RESTORE UPPER LOOP LIMIT INTO TEMPORARY
	JSR PopIV	; RESTORE INCREMENT AND VARIABLE ADDR
	LDA PC+0	; GET PC
	CMP #RetCmd	; WAS A 'RETURN' COMMAND JUST EXECUTED?
	BEQ @XIT	; BRANCH IF YES, THEN EXIT THE LOOP NOW!
	LDA M2+0	; GET THE SIGN OF THE INCREMENT (+ OR -)
	PHP		; SAVE STATUS ON STACK FOR LATER
	JSR PushIV	; SAVE AGAIN FOR POSSIBLE REPEAT OF LOOP
	JSR FetVar	; GO GET THE VARIABLE'S CURRENT VALUE
	JSR FAdd	; ADD THE INCREMENT TO FLAC
	JSR PutVar	; STORE AS NEW LOOP COUNTER VALUE
	JSR PhTmp	; SAVE TEMPORARY ON STACK
	JSR PlFAc2	; PLACE INTO FAc2
	JSR FSub	; SUBTRACT COUNTER FROM UPPER LIMIT
	PLP		; GET SIGN OF THE INCREMENT
	BMI @CNTDWN	; BRANCH IF NEGATIVE, WE ARE COUNTING DOWN
	LDA M1+0	; GET THE SIGN OF THE NUMBER
	BPL @MORFOR	; BRANCH IF REPEAT NECESSARY
@END:	JSR PopIV	; CLEAN UP STACK
@XIT:	LDA ITemp1	; RESTORE PC
	STA PC		;   IN CASE 'RETURN' ENCOUNTERED
	JSR PopJ	; EXIT 'FOR' COMMAND
@CNTDWN: LDA M1+0	; ARE WE LESS THAN THE LOOP LIMIT?
	BEQ @MORFOR	; NO, THEN KEEP GOING
	BPL @END	; YES, THEN THAT'S ALL
@MORFOR: JSR PhTmp	; PLACE UPPER LIMIT BACK ON THE STACK
	BPL @Cont	; UNCONDITIOANALLY REPEAT LOOP


;	    LINE NUMBER MANIPULATION ROUTINES

; "GetLn" GET A LINE NUMBER FROM PROGRAM TEXT.
; RETURNS WITH V=1 IF "ALL" (00.00), OTHERWISE
; IT RETURNS WITH Z=1 IF GROUP NUMBER ONLY (GG.00)
; AND Z=0 IF INDIVIDUAL LINE NUMBER (GG.LL).
;
GetLnC:	JSR FInp	; ONLY ALLOW NUMERIC INPUT
	JMP GetLn1	;   AND ENTER REST OF CODE

GetLnS:	JSR SPNOR	; GET NEXT NON-BLANK
GetLn:	LDA #0		; ASSUME LINE NUMBER IS ZERO
	STA GrpNo
	STA LineNo
	LDA CHAR	; GET FIRST CHARACTER OF EXPRESSION?
	CMP #','	; IS EXPRESSION NULL?
	BEQ GotLnO	; BRANCH IF YES, THEN WE HAVE THE NUMBER
	CMP #$0D	; 'CR' ANOTHER FORM OF NULL?
	BEQ GotLnO	; BRANCH IF YES, THEN WE HAVE THE NUMBER
	JSR TestN	; DOES EXPRESSION BEGIN WITH A NUMBER?
	BCS @X		; BRANCH IF NOT, THEN MUST BE COMPLEX
	JSR GetILN	; CALL INTEGER LINE NUMBER INPUT FOR SPEED
	JMP GotLnO	; WE NOW HAVE THE LINE NUMBER

@X:	JSR PushJ	; CALL 'EVAL' TO EVALUATE EXPRESSION
	  .WORD EVAL	; 'EVAL' ($2A06)
GetLn1:	JSR PhFAc1	; SAVE EXPRESSION VALUE ON STACK
	JSR GETL	; INTEGERIZE AND RANGE CHECK
	STA GrpNo	; SAVE AS GROUP NUMBER
	JSR Float	; NOW Float THE GROUP NUMBER
	JSR PlFAc2	; POP FULL GG.SS INTO FAc2
	JSR FSub	; SUBTRACT OFF THE GROUP NUMBER
	JSR GMul10	; MULTIPLY BY 100
	JSR GMul10
	LDX #FHalf	; MOVE CONSTANT .50
	LDY #FAc2
	JSR MovXY
	JSR FAdd	; NOW ADD IN THE .50 FOR ROUNDING
	JSR GETL	; INTEGERIZE AND RANGE CHECK
	STA LineNo	; SAVE AS LINE NUMBER (STEP NUMBER)
GotLnO:	CLV		; ASSUME NOT 00.00
	LDA GrpNo	; GET GROUP NUMBER
	ORA LineNo	; 'OR' IN THE LINE NUMBER
	BEQ GotAll	; BRANCH IF BOTH ARE ZERO
	LDA GrpNo	; GET GROUP NUMBER AGAIN
	BEQ BadLnO	; BAD LINE NUMBER IS GROUP ONLY IS ZERO
	LDA LineNo	; GROUP NUMBER OK, GET LINE (STEP) NO.
Rts3:	RTS		; RETURN WITH Z=1 IF GROUP ONLY

GotAll:	BIT BITV1	; EXIT WITH V=1, (n=1 ??)
	RTS


; 'LINE NUMBER MANIPULATION ROUTINES'

GETL:	JSR FIX		; FIX THE NUMBER IN FAc1
	LDA M1+0	; GET HIGH ORDERS
	ORA M1+1	; SMASH THEM TOGETHER
	BNE BadLnO	; LINE NUMBER CAN ONLY BE POSITIVE
	LDA M1+2
	CMP #100	; AND < 100 ?
	BMI Rts3
BadLnO:	Trap ILLNO	; ILLEGAL LINE NUMBER (#$FC)

GMul10:	LDX #FTen	; MOVE 10.0
	LDY #FAc2	;   INTO FAc2
	JSR MovXY
	JMP FMul	; * PJMP *  FAc1*FAc2=FAc1


PrntLn: ; PRINT A LINE NUMBER TO OUTPUT DEVICE
	LDY TextP	; GET TEXT POINTER
	LDA (TxtAdr),Y	; GET GROUP NUMBER
	BNE @1		; BRANCH IF NOT ZERO
	INY		; DO NOT PRINT GROUP ZERO LINE NUMBERS
	INY
	STY TextP	; POINT TO FIRST CHARACTER IN LINE
	RTS		;   AND RETURN

@1:	PHA		; SAVE THE GROUP NUMBER FOR LATER
	INY		; POINT TO THE STEP NUMBER
	LDA (TxtAdr),Y	; GET STEP NUMBER
	INY		; MOVE PAST IT
	STY TextP	; SAVE POINTER
	JSR PFLT	; Float THE STEP NUMBER
	JSR Div10	; DIVIDE BY 100
	JSR Div10
	JSR PhFAc1	; SAVE 00.SS FOR LATER
	PLA		; GET THE GROUP NUMBER BACK
	JSR PFLT	; Float IT
	JSR PlFAc2	; RESTORE 00.SS INTO FAc2
	JSR FAdd	; ADD TOGETHER TO FORM GG.SS
			; * PFALL * INTO OUTPUT ROUTINE
	LDA #2		; ASSUME TWO DIGITS BEFORE THE DECIMAL PT.
	TAX		;   AND TWO DIGITS AFTER
	BNE OutLn	; UNCONDITIONAL BRANCH
OutLn0:	LDA #2		; ASSUME TWO DIGITS BEFORE DECIMAL
	LDX #0		; ASSUME NO DECIMAL POINT
OutLn:	TAY		; SAVE NUMBER BEFORE DECIMAL IN Y REG
	LDA M		; SAVE OLD FORMAT ON HARDWARE STACK
	PHA		; (COULD BE CALLED FROM ERROR TRAP)
	LDA N
	PHA
	STY M		; STORE NEW FORMAT
	STX N
	JSR FPrnt	; PRINT NUMBER IN TEMPORARY FORMAT
	PLA		; RESTORE OLD FORMAT
	STA N
	PLA
	STA M
	RTS		; AND RETURN


PFLT:	STA M1+1	; SAVE IN LOW ORDER
	LDA #0		; MAKE HIGH ORDER ZERO
	STA M1+0
	JMP Flt16	; * PJMP * AND Float IT


FindLn: ; FIND A LINE IN THE STORED PROGRAM
  ; RETURNS WITH C=1 IF THE LINE WAS FOUND.
  ;   TxtAd2 POINTS TO THE GROUP NUMBER,
  ; RETURNS WITH C=0 IF THE LINE WAS NOT LOCATED
  ;   TxtAd2 POINTS TO THE GROUP NUMBER OF THE NEXT HIGHEST NO.
  ;     (I.E., WHERE YOU WOULD INSERT THIS LINE)

	LDA GrpNo	; PLACE LINE NUMBER OF LINE WE ARE
	STA ITmp2H	;   LookING FOR INTO TEMPORARY
	LDA LineNo	; STEP PART ALSO
	STA ITmp2L
	LDA #0		; SET FLAG INDICATING FIRST SEARCH
	STA FSwit
	STA TextP	; ALSO RESET TEXT POINTER TO BEGINNING OF
	LDA PC+0	;   CURRENT LINE. IS CURR LN DIRECT CMD?
	BPL @ChkLin	; NO, THEN Start SEARCHING FOR PRESENT POS
@Ini:	JSR TxtIni	; YES, THEN RESET TEXT POINTERS TO Start
	INC FSwit	;   OF PROGRAM, INDICATE LAST SEARCH
@ChkLin: LDY TextP	; GET TEXT POINTER
	LDA (TxtAdr),Y	; GET THE GROUP NUMBER
	CMP #EOP	; END OF TEXT?
	BEQ @NoFind	; BRANCH IF YES
	STA ITmp1H	; SAVE FOR COMPARISON
	STA TGrp	; ALSO SAVE IN CASE THIS ONE IS IT
	INY		; POINT TO STEP NUMBER
	LDA (TxtAdr),Y	; GET IT
	STA ITmp1L	; SAVE IT FOR COMPARISON
	STA TLine+1 ;???	; ALSO SAVE IN CASE THIS IS IT
	INY		; POINT TO FIRST CHAR IN LINE
	STY TextP	; UPDATE TEXT POINTER
	SEC		; SET UP FOR SUBTRACT
	LDA ITmp1L	; GET LOW ORDER
	SBC ITmp2L
	STA ITmp1L	; SAVE FOR LATER
	LDA ITmp1H	; NOW HIGH ORDERS
	SBC ITmp2H
	BMI @Next	; BRANCH IF THE ONE IN THE TEXT AREA IS <
	ORA ITmp1L	; NOT BIGGER, IS IT EQUAL?
	BEQ @Found	; BRANCH IF WE LOCATE THE LINE
	LDA FSwit	; LAST SEARCH ATTEMPT?
	BEQ @Ini	; BRANCH IF NOT, TRY AGAIN FROM Start OF PROGRAM
@NoFind: CLC		; FLAG THE FACT WE DIDN'T FIND IT
@Exit:	LDY #0		; RESET POINTER TO GROUP NUMBER
	STY TextP
	RTS

@Next:	JSR EatCr	; FLUSH TO Start OF NEXT LINE
	BPL @ChkLin	; UNCONDITIONALLY LOOP FOR MORE

@Found:	SEC		; FLAG THE FACT WE FOUND IT
	BCS @Exit	; AND RETURN



;	    UTILITY ROUTINES FOR TEXT MANIPULATIONS

EatCr: ; FLUSH TILL A CARRIAGE RETURN
	INC DebgSw	; DISABLE TRACE
EatCrC:	JSR GetC	; GET NEXT CHAR
	BPL EatCNT	; UNCONDITIONAL BRANCH

EatCr1:	INC DebgSw	; DISABLE TRACE
EatCNT:	LDA CHAR	; GET THE CHAR
	CMP #$0D	; 'CR' ?
	BNE EatCrC	; BRANCH IF NOT
	LDA TxtAdr+0	; YES, CALCULATE THE Start OF NEXT LINE
	CLC
	ADC TextP	; ADD IN THE TEXT POINTER
	STA TxtAdr+0	; SAVE IN POINTER
	STA TxtAd2+0	; AND ALTERNATE POINTER
	LDA TxtAdr+1	; NOW HIGH ORDER
	ADC #0
	STA TxtAdr+1
	STA TxtAd2+1	; AND ALTERNATE POINTER
	LDA #0		; AND RESET THE POINTER
	STA TextP
	STA TextP2
	DEC DebgSw	; ALLOW TRACE AGAIN
	RTS		; AND RETURN


; FLUSH UNTIL END OF COMMAND (SEMI-COLON OR CARRIAGE RETURN)
;
EatEC1:	JSR GetC	; GET NEXT CHAR
	BPL EatECC	; UNCONDITIONAL BRANCH
EatECM:	INC DebgSw	; TURN OFF TRACE
EatECC:	LDA CHAR	; GET THE CHAR
	JSR TstEoc	; GO SEE IF ';' OR CARRIAGE RETURN
	BNE EatEC1	; BRANCH IF NOT
	DEC DebgSw	; ENABLE TRACE AGAIN
	RTS		; AND RETURN


PushTP: ; PUSH THE TEXT POINTERS ON THE STACK
	LDX #TxtAdr
	LDY #4		; THREE PLUS 'CHAR'
	JMP PushB0	; * PJMP *


PopTP: ; POP THE TEXT POINTERS OFF THE STACK
	LDX #TxtAdr+3
	LDY #4
	JMP PopB0	; * PJMP *


TxtIni: ; INIT TEXT POINTER TO BEGINNING OF TEXT
	LDA TxtBeg+0	; POINT TO Start OF STORED TEXT
	STA TxtAdr+0
	LDA TxtBeg+1
	STA TxtAdr+1
	LDA #0		; INIT OFFSET TO ZERO
	STA TextP
	RTS


NewLin: ; SETUP TEXT POINTERS AND PC FOR NEW LINE NUMBER
	LDA GrpNo	; GET THE LINE NUMBER
	STA PC+0	; STORE IN THE PROGRAM COUNTER
	LDA LineNo
	STA PC+1
	LDY #2		; POINT TO FIRST CHAR 0N LINE
	STY TextP
	RTS		; AND RETURN


NxtLin: ; 'NewLin' SETUP TEXT POINTERS AND PC FOR NEXT LINE NUMBER??
	LDY TextP	; GET TEXT POINTER
	LDA (TxtAdr),Y	; PICK UP GROUP NUMBER
	CMP #EOP	; END OF PROGRAM?
	BEQ @NoNext	; BRANCH IF NO NEXT LINE
	STA PC+0	; SAVE AS NEW LINE NUMBER
	INY
	LDA (TxtAdr),Y	; GET STEP NUMBER
	STA PC+1	; STORE IT
	INY		; POINT TO FIRST CHAR ON THE LINE
	STY TextP
	JSR GetC	; GET THE FIRST CHAR OF NEW LINE
	SEC		; FLAG THE FACT WE HAVE A NEW LINE
	RTS		; AND RETURN

@NoNext: CLC		; INDICATE WE HAVE NO NEW LINE
	RTS		; AND RETURN


DELETE: ; A LINE OF STORED PROGRAM
	JSR PushTP	; SAVE TEXT POINTERS
	LDY #2		; SKIP OVER LINE NUMBER
	STY TextP
	JSR EatCr	; SKIP TO THE CARRIAGE RETURN
	JSR PopTP	; RESTORE POINTER TO Start OF LINE TO ZAP
	JSR PushTP	; BUT KEEP THEM AROUND
	LDY #0		; SET OFFSET TO ZERO
@MvLop:	LDA (TxtAd2),Y	; GET A CHAR
	STA (TxtAdr),Y	; MOVE IT DOWN
	CMP #EOP	; END OF TEXT REACHED YET?
	BEQ @Done	; BRANCH IF YES
	INY		; NO, POINT TO NEXT CHAR TO MOVE
	BNE @MvLop	; BRANCH IF NO OVERFLOW ON OFFSET
	INC TxtAdr+1	; OVERFLOW, BUMP HIGH ORDERS
	INC TxtAd2+1
	BNE @MvLop	; UNCONDITIONAL

@Done:	INY
	STY TextP	; SAVE OFFSET
	LDA TxtAdr+0	; set VarBeg to new end-of-text
	CLC
	ADC TextP
	STA VarBeg+0
	LDA TxtAdr+1
	ADC #0
	STA VarBeg+1
	JSR InsDon	; FLAG VARIABLE LIST AS EMPTY
	JMP PopTP	; * PJMP * RESTORE POINTERS TO POINT TO
			;   WHERE WE WOULD INSERT LINE.


INSERT: ; A LINE IN THE STORED PROGRAM TEXT AREA
	JSR PushTP	; SAVE TEXT POINTERS ACROSS CALL
	JSR FindLn	; TRY TO LOCATE THE LINE
	BCC @CNT	; BRANCH IF LINE DOES NOT EXIST
	JSR DELETE	; LINE EXISTS, DELETE IT
	JSR FindLn	; RE-FIND TO SET UP POINTERS AGAIN
@CNT:	JSR PopTP	; GET ComBuf POINTERS BACK
	DEC TextP	; POINT TO THE LINE NUMBER DELIMITER
	JSR PushTP	;   BUT KEEP THEM AROUND
	LDX #TxtAd2	; SAVE POINTER TO PLACE TO INSERT
	LDY #4		;   ON STACK
	JSR PushB0
	LDX #2		; SET COUNTER FOR 3 BYTES MINIMUM
@IFCR:	INX		; COUNT THIS BYTE
	JSR GetC	; GET IT FROM COMMAND BUFFER
	CMP #$0D	; 'CR' ?
	BNE @IFCR	; NO, KEEP COUNTING
	STX Temp1	; SAVE COUNTER TEMPORARILY
	LDY #0
	LDA (TxtAd2),Y	; GET THE LAST CHAR TO SLIDE DOWN
	PHA		; SAVE FOR LATER
	LDA #UMark	; FLAG THE LOC
	STA (TxtAd2),Y
	LDA VarBeg+0	; GET ADDR OF Start OF VARIABLE LIST
	STA TxtAdr+0	; SAVE FOR LATER
	CLC
	ADC Temp1	; ADD IN AMOUNT TO MOVE DOWNWARD
	STA TxtAd2+0	; SAVE FOR LATER
	STA VarBeg+0	; SAVE AS NEW Start OF VARIABLE LIST
	LDA VarBeg+1	; NOW HIGH ORDER
	STA TxtAdr+1
	ADC #0
	STA TxtAd2+1
	STA VarBeg+1	; AND FALL INTO MOVE LOOP
@MvLop:	LDA (TxtAdr),Y	; PICK UP A BYTE
	CMP #UMark	; END OF MOVE?
	BEQ @MvDon	; BRANCH IF YES
	STA (TxtAd2),Y	; NO, THEN SLIDE IT DOWN
	DEY		; DECREMENT OFFSET?
	CPY #$FF	; OVERFLOW?
	BNE @MvLop	; BRANCH IF NOT
	DEC TxtAdr+1	; OVERFLOW, BUMP HIGH ORDER
	DEC TxtAd2+1	;   ADDRESSES
	BNE @MvLop	; UNCONDITIONALLY LOOP FOR MORE

@MvDon:	PLA		; GET THE LAST BYTE BACK AGAIN
	STA (TxtAd2),Y	; STORE IT AWAY
	JSR PopTP	; RESTORE POINTERS TO PLACE TO INSERT
	LDX #TxtAd2+3	; RESTORE POINTERS TO ComBuf
	LDY #4
	JSR PopB0
	LDY TextP	; GET OFFSET
	LDA GrpNo	; GET THE GROUP NUMBER
	STA (TxtAdr),Y	; STRORE IT IN PROGRAM AREA
	INY
	LDA LineNo	; GET THE STEP NUMBER
	STA (TxtAdr),Y	; STRORE IT IN PROGRAM AREA
	INY		; POINT TO WHERE FIRST CHARACTER GOES
	STY TextP	; SAVE IT FOR LATER
@InsLop: LDY TextP2	; GET POINTER TO CHAR
	LDA (TxtAd2),Y	; PICK IT UP
	INY		; BUMP IT
	STY TextP2	; STORE IT BACK
	LDY TextP	; POINT TO WHERE IT GOES
	STA (TxtAdr),Y	; PUT IT THERE
	CMP #$0D	; CARRIAGE RETURN YET?
	BEQ InsDon	; BRANCH IF YES
	INY		; NO, POINT TO NEXT
	STY TextP	; SAVE POINTER
	BNE @InsLop	; UNCONDITIONALLY LOOP FOR MORE

InsDon: ; empty variable list
	LDY #0
	LDA #EOV	; FLAG VARIABLE LIST AS EMPTY
	STA (VarBeg),Y
	LDA VarBeg+0	; AND UPDATE 'VarEnd'
	STA VarEnd+0
	LDA VarBeg+1
	STA VarEnd+1
	RTS


;	    'SOFTWARE STACK MANIPULATION ROUTINES'

PushJ: ; PUSH-JUMP TO A ROUTINE
  ;
  ; CALLING SEQUENCE IS:
  ;
  ; JSR  PushJ	; CALL THIS SUBROUTINE
  ; .WORD ROUTINE	; TWO BYTE ADDR OF ROUTINE TO GO TO
  ;		; *** NOTE! THIS WORD CANNOT start at xxFE or xxFF.
  ;	 <----- ; RETURN IS HERE VIA "PopJ" ROUTINE
  ;
  ; *** this routine has self-modifying code
  ;
	PLA		; GET LOW ORDER RETURN ADDR FROM STACK
	TAY		; PLACE IN Y REGISTER
	INY		; INCREMENT TO GET LOW ORDER TO JUMP INDIR
	STY @Jmp+1	; STORE IN JUMP INDIRECT INSTRUCTION
	INY		; BUMP FOR THE RTS IN "PopJ"
	TYA		; PLACE IN ACCUMULATOR
	JSR PushA	; SAVE ON STACK FOR LATER
	PLA		; GET HIGH ORDER RETURN ADDR
	STA @Jmp+2	; STORE IN JUMP INDIRECT INSTRUCTION
	JSR PushA	; SAVE FOR LATER RETURN VIA "PopJ"
@Jmp:	JMP (0)		; ADDR IS OVERWRITTEN FROM ABOVE CODE
			; THIS JUMP WILL GO TO "ROUTINE".

PushA: ; PUSH THE ACCUMULATOR ON THE SOFTWARE STACK
	LDY PDP		; GET THE SOFTWARE STACK POINTER
	STA (PdpAdr),Y	; STORE THE ACC VIA POINTER
	DEY		; DECREMENT THE SOFT STACK POINTER
	CPY #$FF	; IS NEW VALUE $FF ?
	BNE @RT		; NO, THEN BASE ADDR IS ok
	DEC PdpAdr+1	; YES, DEC BASE ADDR BY ONE
@RT:	STY PDP		; STORE UPDATED POINTER
	RTS


PopA: ; POP ITEM OFF SOFTWARE STACK INTO THE ACCUMULATOR
	LDY PDP		; load software stack pointer
	INY		; increment so it points to new item
	BNE @OK		; branch if high-order base addr is OK
	INC PdpAdr+1	; if not OK, increment by one page
@OK:	LDA (PdpAdr),Y	; get item from soft stack
	STY PDP		; store updated pointer
	RTS


PopJ: ; RETURN TO ADDRESS SAVED BY A CALL TO "PushJ"
	TSX		; load X w/ hw stack pointer
	JSR PopA	; get hi order addr to ret to
	STA RStack+2,X	; overwrite return addr
	JSR PopA	; get lo order byte to ret to
	STA RStack+1,X	; overwrite return addr
	RTS		; return to proper place, past
			;   JSR PushJ and .WORD routine
			;     SEQUENCE --->

PopB2:	LDY #2		; entry point when we need 2 bytes only
PopB0: ; pop Y bytes off of stack into zero page ending at X
	STY Temp1	; save Y register
	JSR PopA	; get a byte from stack
	STA 0,X		; store it in zero page
	LDY Temp1	; get Y register back
	DEX		; count X down
	DEY		; done yet?
	BNE PopB0
	RTS


PushB2:	LDY #2		; entry point, 2 bytes only
PushB0: ; push Y bytes from page zero starting at X onto stack
	STY Temp1	; save Y
	LDA 0,X		; get value from ZPage
	JSR PushA	; save on stack
	LDY Temp1	; get Y back
	INX		; next byte
	DEY		; done yet?
	BNE PushB0
	RTS


; PUSH AND POP F.P. NUMBERS

PhFAc1: ; PUSH FAc1 ONTO STACK
	LDX #$FB	; get neg of num of bytes to push
@B:	LDA FAc1+5,X	; get a byte of number
	JSR PushA	; push onto software stack
	INX		; point to next one
	BMI @B		; loop til all pushed
	RTS


PhFAc2: ; PUSH FAc2 ONTO STACK
	LDX #$FB	; get neg of num of bytes to push
@B:	LDA FAc2+5,X	; get a byte of number
	JSR PushA	; etc
	INX
	BMI @B
	RTS


PhTmp: ; PUSH F.P. TEMP ONTO STACK
	LDX #$FB	; get neg of num of bytes to push
@B:	LDA T+5,X	; get a byte of number
	JSR PushA	; etc
	INX
	BMI @B
	RTS


PlFAc2: ; POP NUMBER ON STACK INTO FAc2
	LDX #4		; point to last byte
@B:	JSR PopA	; pop item from stack into ACC
	STA FAc2,X	; store into FAc2
	DEX		; point to next byte
	BPL @B		; loop until all popped
	RTS


PlTmp: ; POP NUMBER ON STACK INTO F.P. TEMP
	LDX #4		; point to last byte
@B:	JSR PopA	; get item from stack into ACC
	STA T,X		; store in temp area
	DEX		; point to next byte
	BPL @B		; loop til done
	RTS


;	    'CHARACTER MANIPULATING ROUTINES'

RNoEch: ; READ ONE CHARACTER WITH NO ECHO
	LDA EchFlg	; get echo ctrl flag
	PHA		; save on stack
	LDA #1		; no disable echo
	STA EchFlg
	JSR ReadC	; get a char from input device
	TAX		; save char into X
	PLA		; get old echo flag value back
	STA EchFlg
	TXA		; get the char input
	RTS


ReadC: ; READ ONE CHARACTER FROM INPUT DEVICE
	LDX IDev	; GET CURRENT INPUT DEVICE NUMBER
	BPL @1		; BRANCH IF DEVICE NUMBER IS POSITIVE
	JMP RStrng	; * PJMP * NEG, READ FROM STRING AND RET

@1:	LDA IDSPH,X	; GET HIGH ORDER DISPATCH ADDRESS
	STA Temp1+1	; STORE IT AWAY
	LDA IDSPL,X	; GET LOW ORDER
	STA Temp1	; STORE IT AWAY
	JSR JsrInd	;   AND CALL THE INPUT ROUTINE
	BCC ReadCC	; BRANCH IF NO ERRORS
IERRI:	JSR ClrDev	; RESET DEVICES ON AN I-O ERROR
	Trap ERRI	; ?I-O ERROR ON INPUT DEVICE (#$E9)

ReadCC:	STA CHAR	; SAVE CHAR
	CMP #$7F	; here the Aresco code differs from the
	BEQ Rts1	; ProgExch/6502Grp original. Was only a
	CMP #LinChr	; test for CR, but now testing for RUBOUT,
	BEQ Rts1	; LF and CXL LINE.
	CMP #$0A	;   --dhh
	BEQ Rts1
	LDA EchFlg	; echo flag
	BEQ ReadCE
ReadCR:	LDA CHAR	; GET CHAR BACK
	RTS

ReadCE:	LDA CHAR	; this is also not in original code...
	JSR PrintC
	CMP #$0D
	BNE Rts1	; ... to here. Next line was label ReadCE
	LDA #$0A	; FOLLOW CARRIAGE RETS WITH A LINE FEED
	JSR PrintC	; PRINT IT
	BPL ReadCR	; UNCONDITIONAL BRANCH


PSpace:	LDA #$20	; OUTPUT A SPACE
PrintC: ; PRINT THE CHAR IN ACCUMULATOR OR 'CHAR'
	AND #$FF	; here we're testing for a null ($00),
	BNE PRNTC	; otherwise, routine branches to the
	LDA CHAR	; original ProgExch 'PrintC'
PRNTC:	PHA		; SAVE THE CHAR IN THE AC
	LDX ODev	; GET CURRENT OUTPUT DEVICE NUMBER
	BPL @USEA1	; BRANCH IF DEVICE NUMBER IS POSITIVE

       ; ProgExch source has a 'patch' here (literally pasted on!)
       ; covering the next six bytes:
       ; LDY StOPnt   ; get pntr to next char
       ; JMP WStrng   ; *PJMP* write to string
       ; NOP		; patch fill

	JSR WStrng
	JMP PRRET


@USEA1:	LDA ODSPH,X	; GET HIGH ORDER ADDR OF OUTPUT ROUTINE
	STA Temp1+1
	LDA ODSPL,X	; GET LOW ORDER ADDR OF OUTPUT ROUTINE
	STA Temp1+0
	PLA		; GET CHAR BACK
	PHA		; BUT SAVE ACROSS CALL
	JSR JsrInd	; CALL THE ROUTINE TO DO THE OUTPUT
	BCC PRRET	; BRANCH IF NO ERRORS
OERRO:
	JSR ClrDev	; RESET I-O DEVICES IF ERROR
	Trap ERRO	; ?I-O ERROR ON OUTPUT DEVICE (#$DE)

PRRET:	PLA		; RESTORE THE CHARACTER
	RTS		; AND RETURN


PackC: ; PACK A CHAR INTO MEMORY
	LDA CHAR	; get character
PackC1:	LDY TextP	; get text pointer
	CMP #$7F	; rubout?
	BEQ Rub1	; yes, branch
	CMP #LinChr	; 'line delete' char?
	BEQ RubLin	; yes, branch
	STA (TxtAdr),Y  ; store char to memory
PCKRUB:	INY		; +1 text pointer
	CPY #LineL	; over max line length?
	BPL PBIG	; yes, branch
PCKRET:	STY TextP	; save text pointer
Rts1:	RTS		; and return

PBIG:	Trap LTL	; ?line too long


Rub1: ; RUB OUT ONE CHARACTER
	CPY #0		; anything to rubout?
	BEQ PCKRET	; nope, branch
	LDY EchFlg	; has user enabled character echo?
	BNE @CC		; branch if disabled
	LDY DelSpl	; need special CRT rubout?
	BEQ @C		; branch if not
	JSR EatTvC	; yes, eat the char
	BPL @CC		; uncond. branch

@C:	LDA #$5C	; echo sp char '\' for rubout
	JSR PRNTC
@CC:	LDY TextP	; load Y with text pointer
	DEY		; -1
	BPL PCKRET	; RET if positive
	BMI PCKRUB	; if past beginning, set to 0


RubLin: ; RUB OUT THE ENTIRE LINE
	CPY #0		; anything to rubout?
	BEQ PCKRET	; branch if not
	LDY EchFlg	; has user enabled char echo?
	BNE @R		; branch if disabled
	LDY DelSpl	; need special CRT rubout proc?
	BEQ @C		; branch if not
@CL:	JSR EatTvC	; eat a char off CRT screen
	DEC TextP	; zap it from buffer
	BNE @CL	 	; loop til all zapped
	RTS

@C:	LDA #LinChr	; echo 'line del' character
	JSR PRNTC
@R:	LDY #0		; reset text pointer
	BEQ PCKRET	; and RET


EatTvC: ; EAT A CRT CHAR WITH BS-SPC-BS SEQUENCE
	JSR @Back	; output a BS
	JSR PSpace	; followed by a space
@Back:	LDA #$08	; get BS char
	JMP PrintC	; * PJMP * output it and return


; 'GetC' GET A CHAR FROM MEMORY, ECHO IF TRACE ON
;
GetCX:	LDY DebgSw	; is trace disabled?
	BNE GetC1	; yes, don't Look at flag
	LDA DmpSw	; flip state of the dump switch
	EOR #$FF
	STA DmpSw	; and store it back
GetC:	LDA INSW	; where do we get the char from?
	BEQ @C		; from memory
	JMP ReadC	; * PJMP * go get from input dev

@C:	LDY TextP	; get text pointer
	INC TextP	; +1 to next char
	LDA (TxtAdr),Y  ; get it
	CMP #'?'	; is it '?'
	BEQ GetCX	; yes, go handle
GetC1:	STA CHAR	; store away for others
	LDA DebgSw	; check to see if we print it
	ORA DmpSw	; for debugging
	BNE @RT1	; no
	JSR ReadCE	; print only if both are 0
@RT1:	LDA CHAR	; get char back
	RTS		; and RET


    ; the ProgramExchange/6502Group code has a 'patch'
    ; over GetC1:
    ; GetC1	STA CHAR     ; STORE IT
    ;		PHA	     ; SAVE ON STACK
    ;		LDA DebgSw     ; DO WE PRINT IT?
    ;		ORA DmpSw     ; FOR DEBUGGING
    ;		BNE TestN+7	; NO
    ;		PLA	     ; GET CHAR BACK
    ;		JSR TRACBG     ; FIX FOR TRACE BUG
    ;		RTS	     ; CHAR IS RETURNED


; 'SPNOR' ROUTINE TO IGNORE LEADING SPACES
;
GSPNOR:	JSR GetC	; CALL GetC FIRST
SPNOR:	LDA CHAR	; GET THE CHAR
	CMP #$20	; IS IT A SPACE?
	BEQ GSPNOR	; YES, THEN IGNORE
	RTS		; NO, RETURN


; "TestN"  TESTS TO SEE IF CHARACTER IS A NUMBER
;
TestNS:	JSR GSPNOR	; GET NEXT NON-BLANK
TestN:	LDA CHAR	; GET CHAR
TestN1:	PHA		; SAVE CHAR ON STACK
	EOR #'0'	; CONVERT TO BCD (IF A NUMBER)
	CMP #$0A	; SET C BIT IF GREATER THAN 9
	PLA		; RESTORE CHARACTER TO ACCUMULATOR
	RTS		; RETURN (C BIT CLEAR IF NUMBER)


;	    'EVAL' - EXPRESSION EVALUATOR

; 'EVAL' - EVALUATE AN EXPRESSION (RECURSIVE)

EFun: ; a function
	LDA #0		; Hash the function name
@L:	ASL A
	STA ETemp1	;   SAVE IT
	JSR GetC	;   GET NEXT CHARACTER OF FUNCTION NAME
	JSR TTerms	;   TERMINATOR?
	BEQ @Name	;   BRANCH IF END OF NAME
	AND #$1F	;   KEEP ONLY 5 BITS
	CLC
	ADC ETemp1	;   ADD IN THE Hash
	BNE @L		;   UNCONDITIONALLY LOOP FOR MORE

@Name:	CMP #'('	; LEFT PAREN?
	BEQ @EFunc	; BRANCH IF YES
	Trap PFERR	; ?PARENTHESES ERROR IN FUNCTION

@EFunc:	LDA ETemp1	; GET THE Hash CODE FOR FUNCTION NAME
	JSR PushA	; SAVE FOR LATER
	JSR PushJ	; MOVE PAST PAREN, EVALUATE 1ST ARGUMENT
	  .word EvalM1
	JSR PopA	; GET THE NAME BACK AGAIN
	TAX		; TRANSFER TO X REGISTER
	JSR PushJ	; AND GO DO THE FUNCTION
	  .word FUNC
	JMP ERPar	; GO SEE IF TERMINATOR IS A RIGHT PAREN.

EChar: ; A QUOTED CONSTANT
	JSR GetC	; GET CHARACTER FOLLOWING QUOTE
	JSR Flt8	; AND MAKE IT A FloatING POINT NUMBER
	JSR GetC	; MOVE PAST CHARACTER
	JMP OpNext	; AND CHECK FOR OPERATOR


; *** MAIN ENTRY POINT(S) TO 'EVAL' ***
;
EvalM1:	JSR GetC	; ENTER HERE TO GET PAST CURRENT CHARACTER
EVAL:	LDA #0		; ASSUME LOWEST LEVEL ARITHMETIC OPERATION
	STA LastOp
	STA StrSwt	; MAKE SURE STRING VAR SWITCH IS OFF
	JSR ZrFAc1	; ASSUME VALUE OF EXPRESSION IS ZERO
ARGNXT:	LDA LastOp	; SAVE LAST OPERATION ON STACK
	JSR PushA
	JSR TTerms	; GO SEE IF THIS CHARACTER IS A TERMINATOR
	BNE @ECHKC	; BRANCH IF NOT
	JMP ETERM1	; YES, THEN HANDLE

@ECHKC:	CMP #'F'	; IS IT A FUNCTION?
	BEQ EFun
	CMP #$27	; ''' IS IT A CHARACTER CONSTANT?
	BEQ EChar
	CMP #'.'	; IS IT A FRACTION?
	BEQ @ENum
	JSR TestN1	; IS IT A NUMBER?
	BCS @EGTVAR	;   BRANCH IF NOT A NUMBER
	      ; *** Start OF KLUDGE HACK
	      ;	    TO SPEED THINGS UP ***
	LDA INSW	; ARE WE INPUTTING FROM INPUT DEVICE?
	BNE @ENum	; BRANCH IF YES, CALL Float PT ROUTINE
	LDX #2		; NO, THEN WE CAN Look AHEAD TO SEE IF
	LDY TextP	;   CONSTANT IS IN RANGE 0-99
@KLoop:	LDA (TxtAdr),Y  ; GET NEXT CHAR
	INY		; BUMP POINTER
	CMP #'.'	; DOES NUMBER HAVE A FRACTIONAL PART
	BEQ @ENum	;   BRANCH IF IT DOES, CALL F.P. ROUTINE
	JSR TestN1	; IS THIS CHAR A DIGIT 0-9 ALSO?
	BCS @FstNum	; BRANCH IF NOT, THEN CALL FAST INPUT
	DEX		; CAN ONLY HAVE UP TO TWO DIGITS
	BNE @KLoop	; Look AT NEXT ONE
			; IF WE FALL OUT OF THE LOOP, WE HAVE TO
@ENum:	JSR FInp	;   CALL Float PT. INPUT ROUTINE (SLOW!)
	JMP OpNext	; AND LOOP FOR OPERATOR

@FstNum: LDA CHAR	; GET FIRST DIGIT OF NUMBER
	JSR GETIN	; CALL FAST INPUT ROUTINE FOR #S 0-99
	JSR Flt8	; CALL FAST ONE-BYTE Float ROUTINE
	JMP OpNext	;    AND Look FOR OPERATOR
			; *** END OF KLUDGE HACK ***

@EGTVAR: JSR PushJ	; IT MUST BE A VARIABLE, GET VALUE
	  .word GetVar
	LDA CHAR	; GET CHARACTER THAT TERMINATED THE VARIB
	CMP #'='	; DOES HE WANT SUBSTITUTION?
	BNE OpNext	;   BRANCH IF NOT, JUST A TERM
	LDX #VarAdr	; YES, THEN SAVE THE INFO ABOUT THIS VARIB
	LDY #5
	JSR PushB0	;   ONTO THE STACK
	JSR PushJ	; CALL OURSELVES TO EVAL THE EXPRESSION
	  .word EvalM1
	LDX #VarAdr+4	; RESTORE POINTERS TO VARIABLE
	LDY #5
	JSR PopB0
	LDA StrSwt	; WAS THE VARIABLE A STRING VARIABLE?
	BNE @SetStr	; BRANCH IF IT WAS
	JSR PutVar	; NO, THEN STORE EXPRESS VALUE AS VARIB'S
	BEQ OpNext	;   VALUE - IS ALSO VALUE OF THIS TERM
@SetStr: JSR Intger	; KEEP ONLY 8 BITS FOR VALUE
	LDY VSub+1	; POINT TO POSITION IN STRING
	STA (VarAdr),Y  ; STORE IT INTO $, FALL INTO...
OpNext:	JSR TTerms	; GO SEE IF NEXT NON-SPACE IS SPECIAL
	BNE @MISOPR	; BRANCH IF NOT
	CPX #6  	; LEFT PAREN?
	BNE OpNxt1	; NO, THAT'S GOOD AS WE CAN'T HAVE 1 HERE
@MISOPR: Trap OPRMIS	; ?OPERATOR MISSING - EVAL

JARGN:	JMP ARGNXT	; BRANCH AID

EVALRT:	JSR PopJ	; RETURN FROM CALL TO "EVAL"

OpNxt1:	CPX #7		; IS THIS A DELIMITER?
	BMI @PNXT2	; BRANCH IF NOT
	LDX #0		; YES, THEN THE OPERATION LEVEL IS LOWEST
@PNXT2:	JSR PopA	; GET LAST OPERATION LEVEL
	STA Temp1	; SAVE IT FOR COMPARE
	CPX Temp1	; IS THIS OPER LVL < OR = TO LAST ONE?
	BMI @DOBOP	; BRANCH IF YES
	BNE @ESTACK	; BRANCH IF NO

@DOBOP:	ORA #0		; TO RESET FLAGS AFTER CPX
	STA LastOp	; YES, THEN GET THE LAST OPERATOR
	BEQ EVALRT	; IF LOWEST LEVEL, THEN WE ARE ALL DONE
	TXA		; SAVE 'THISOP'
	PHA		; ON HARDWARE STACK
	JSR PlFAc2	; POP PARTIAL RESULT BACK INTO FAc2
	JSR EVBOP	; AND GO DO THE OPERATION LEAVING THE
			;   RESULT IN FLAC
	PLA		; GET 'THISOP' BACK
	TAX
	BPL @PNXT2	; UNCOND. BRANCH WITH NEW PARTIAL RESULT.

@ESTACK: JSR PushA	; SAVE BACK ON STACK FOR LATER COMPUTATION
	STX LastOp	; NOW UPDATE 'LastOp' TO 'THISOP'
	JSR PhFAc1	; SAVE PARTIAL RESULT ON STACK
	JSR GetC	; SKIP OVER THE OPERATOR
	BPL JARGN	; UNCOND. BRANCH TO PICK UP NEXT ARGUMENT
ETERM1:	CPX #6		; LEFT PAREN?
	BNE ETERM2	; BRANCH IF NOT
	JSR PushJ	; ENTERING NEW LEVEL OF NESTING, SO CALL
	  .word EvalM1	; OURSELVES TO EVALUATE IT!
ERPar:	LDA CHAR	; GET THE DELIMITER THAT ENDED THIS LEVEL
	PHA		; SAVE IT MOMENTARILY
	JSR GetC	; MOVE PAST IT
	PLA		; GET DELIMITER BACK
	CMP #')'
	BEQ OpNext	; YES. GO PICK UP NEXT OPERATOR
EPMISS:	Trap PMATCH	; ?PARENTHESIS MISMATCH - EVAL

ETERM2:	CPX #7		; DELIMITER ON RIGHT-HAND SIDE?
	BPL @ET3	; BRANCH IF YES
	CPX #3		; OR UNARY OPERATOR
	BPL @MisOpn	; NO, THEN IT CAN'T BE HERE
@ET3:	LDA LastOp	; PICK UP OPERATION LEVEL
	BEQ OpNxt1	; ONLY ALLOW IF AT LOWEST LEVEL
@MisOpn: Trap OPNMIS	; ?OPERAND MISSING - EVAL


EVBOP:	LDX LastOp	; GET THE ARITHMETIC OPERATION TO PERFORM
	LDA EVDSPH-1,X	; GET THE HIGH-ORDER ADDR OF ROUTINE
	STA Temp1+1	; STORE IT
	LDA EVDSPL-1,X	; GET THE LOW-ORDER ADDR OF ROUTINE
	STA Temp1	; STORE IT
	JMP (Temp1)	; * PJMP * TO ROUTINE TO DO THE OPERATION


EvPowr: ;	    EVALUATE A POWER
  ; *** NOTE: THIS ROUTINE IS CURRENTLY RESTRICTED TO RAISING
  ;	    THE NUMBER TO AN INTEGER POWER WITHIN THE RANGE
  ;	    OF + OR - 32,767

	JSR IntFix	; GET EXPONENT
	STA ITmp1L	; STORE IT AWAY
	LDA M1+1	; AS NUMBER OF TIMES TO DO OPERATION
	STA ITmp1H
	LDX #FOne	; GET THE CONSTANT 1.0 INTO FAc1
	LDY #FAc1
	JSR MovXY
	LDA ITmp1H	; RAISING TO A NEGATIVE POWER?
	BMI @NPOWR	; BRANCH IF WE ARE
@LP:	LDA #$FF	; POSITIVE POWER, ARE WE DONE YET?
	DEC ITmp1L
	CMP ITmp1L
	BNE @1		; BRANCH IF HIGH ORDER OK
	DEC ITmp1H	; DECREMENT HIGH ORDER
@1:	CMP ITmp1H	; DONE YET?
	BEQ TTRet	; YES, THEN RETURN
	JSR PhFAc2	; NO, SAVE FAc2
	JSR FMul	; NUMBER TIMES ITSELF (EXCEPT FIRST TIME)
	JSR PlFAc2	; RESTORE NUMBER TO FAc2
	JMP @LP		; AND KEEP MULTIPLYING

@NPOWR: ; RAISING TO A NEGATIVE POWER
	LDA ITmp1H	; DONE YET?
	BEQ TTRet	; BRANCH IF ALL DONE
	INC ITmp1L	; NO, THEN COUNT UP SINCE COUNT IS NEG.
	BNE @N1
	INC ITmp1H	; INCREMENT HIGH ORDER ALSO
@N1:	JSR Swap	; PUT PARTIAL INTO FAc2, 'X' INTO FAc1
	JSR PhFAc1	; SAVE 'X'
	JSR FDiv	; 1/(X*X*X*X...)
	JSR PlFAc2	; RESTORE 'X'
	JMP @NPOWR	; AND LOOP TILL DONE


;	    'ROUTINES USED BY "EVAL" '

TTerms: ; TEST TO SEE IF CHARACTER IS A SPECIAL TERMINATOR
	JSR SPNOR	; IGNORE SPACES, GET NEXT NON-BLANK CHAR
	LDX #TrMax	; GET MAX TABLE OFFSET
@Chk:	CMP TrmTab,X	; MATCH?
	BEQ TTRet	; YES, RETURN WITH Z=1
	DEX		; POINT TO NEXT ENTRY
	BPL @Chk	; AND CHECK IT
TTRet:	RTS		; RETURN (NOTE: Z=0 IF CANNOT FIND)


;	    'GetVar' - GET A VARIABLE FROM VARIABLE LIST
;
; "GetVar" - GET A VARIABLE FROM THE VARIABLE LIST
;	     OTHERWISE CREATE IT AND ASSIGN IT A VALUE OF ZERO
;
GPMISS:	JMP EPMISS	; BRANCH AID

GtErr3:	Trap FunIll	; ?FUNCTION ILLEGAL HERE

GetVar:	LDA #0		; ASSUME VARIABLE IS NOT A STRING
	STA StrSwt
	JSR SPNOR	; (DEFENSIVE!) GET THE CHARACTER
	CMP #'&'	; IS IT SPECIAL 'FSBR' SCRATCH VARIB?
	BEQ @OK		;   YES, THEN NAME IS OK
	CMP #'A'	; IS IT ALPHABETIC?
	BMI @Bad	;   BRANCH IF NOT
	CMP #'Z'+1
	BMI @OK		; BRANCH IF ALPHABETIC
@Bad:	Trap BadVar	; ?BAD VARIABLE NAME

@OK:	CMP #'F'	; FUNCTION?
	BEQ GtErr3	;   BRANCH IF YES
	ASL A
	ASL A
	ASL A		; SHIFT ALPHA LEFT 3
	PHA		; SAVE IT
	JSR GetC	; GET NEXT CHARACTER
	EOR #'0'	; CONVERT TO BCD IF A NUMBER
	CMP #8		; IS IT 0-7?
	BCS @DUN	;   IF NOT, NAME IS ON STACK
	STA VCHAR	; SAVE IT
	PLA	 	; GET BACK ALPHA PART
	ORA VCHAR	; PUT THE PARTS TOGETHER
	PHA		; AND STICK ON STACK
	JSR GetC	; GET A NEW CHARACTER IN CHAR


; X X X X X X X X X X X X X X X X X X X X X X X X X X X
;
; *** here begins work done by Nils Andreas (2023)


@DUN:	LDA CHAR
	CMP #'$'	;STRING VARIABLE?
	BNE @DN1	;  BRANCH IF NOT, PRESS ON
	STA StrSwt	;FLAG THE FACT
	JSR GetC	;MOVE PAST THE '$'
@DN1:	PLA		;GET VARIABLE OFF STACK
	JSR PushA	;PUT NAME ON SOFT STACK
	JSR SPNOR	;GET NEXT NON-BLANK
	CMP #'('
	BEQ @SUB	;BRANCH IF VARIABLE HAS A SUBSCRIPT
	LDA #0		;OTHERWISE ASSUME 0
	STA VSub+1	;ZERO THE SUBSCRIPT
	BEQ @SOK	;AND ProcesS IT

@SUB:	LDA StrSwt	;SAVE STRING FLAG
	JSR PushA
	JSR PushJ	;CALL EVAL TO CALCULATE SUBSCRIPT
	  .word EvalM1
	JSR PopA	;RESTORE STRING FLAG
	STA StrSwt
	LDA CHAR	;GET TERMINATOR
	CMP #')'	;PAREN MATCH?
	BNE GPMISS	;  BRANCH IF NOT
	JSR GetC	;MOVE PAST THE RIGHT PAREN (TYPO?)
	JSR FIX		;MAKE SUBSCRIPT AN INTEGER
	LDA M1+2	;GET LOW ORDER BYTE
	STA VSub+1	;STORE IT
	LDA M1+1	;GET HIGH ORDER BYTE (NOTE:16 BIT)
@SOK:	STA VSub+0	;SAVE FOR LATER
	JSR PopA	;GET THE VARIABLE NAME BACK
	STA VCHAR	;SAVE IT

FndVar:	JSR VarIni	;SET ADDR TO Start OF VARIABLE LIST
ChkVar:	LDY #0
	LDA (VarAdr),Y	;GET THE VARIABLE NAME
	CMP #EOV	;IS THIS THE END OF THE VARIABLE LIST?
	BEQ NOVAR	;  BRANCH IF END OF LIST
	CMP #StrMrk	;IS THIS VARIABLE IN THE LIST A STRING VARIABLE?
	BEQ ChkStr	;  BRANCH IF YES, WE HANDLE DIFFERENTLY
	CMP VCHAR	;ARE THE NAMES THE SAME
	BEQ CHKSUB	;  YES, GO SEE IF THE SUBSCRIPTS ARE EQUAL
NotVar:	JSR NxtVar	;POINT TO NEXT VARIABLE IN LIST
	BNE ChkVar	;UNCONDITIONAL BRANCH TO CHECK NEXT VARIABLE
ChkStr:	LDA StrSwt	;ARE WE LookING FOR A STRING VARIABLE?
	BEQ SKPSTR	;BRANCH IF NOT, JUST SKIP OVER THIS STRING VARIB
	LDA VCHAR	;YES, THEN GET IT'S NAME
	INY		;POINT TO NAME OF STRING VARIABLE IN VAR LIST
	CMP (VarAdr),Y	;IS THIS THE ONE WE ARE LookING FOR?
	BNE SKPST1	;BRANCH IF NOT, JUST SKIP IT OVER
	INY		;YES, THIS IS THE ONE, GET THE SIZE OF THE
	LDA (VarAdr),Y	;STRING
	STA VSize	;STORE FOR THOSE WHO NEED IT
	INY		;AND UPDATE
	TYA
	JSR UpdVar	;TO POINT TO BASE ADDR OF STRING
GETSTC:	LDY VSub+1	;GET SUBSCRIPT (POSITION) OF BYTE WE WANT
	LDA (VarAdr),Y	;GET THE BYTE WE WANT
	STA M1+1	;STORE AS LOW ORDER 8 BITS
	LDA #0
	STA M1+0	;ZERO HIGH ORDER
	JMP FL16PJ	;*PJMP* Float AND RETURN THE VALUE

SKPSTR:	INY		;MOVE OVER STRING VARIABLE'S NAME
SKPST1:	INY		;POINT TO STRING VARIABLE'S LENGTH
	LDA (VarAdr),Y	;GET THE STRING LENGTH
	PHA		;SAVE IT
	INY		;POINT TO FIRST BYTE IN STRING
	TYA		;UPDATE 'VarAdr' TO BASE OF STRING
	JSR UpdVar
	PLA		;GET SIZE OF STRING
	JSR UpdVar	;UPDATE 'VarAdr' BY PROPER AMOUNT
	BNE ChkVar	;AND Look FOR NEXT VARIABLE IN LIST

CHKSUB:	LDA StrSwt	;ARE WE LookING FOR A STRING VARIABLE
	BNE NotVar	;BRANCH IF WE ARE, CAN'T BE THIS NUMERIC VARIABLE
	LDA VSub	;GET HIGH ORDER SUBSCRIPT WE ARE LookING FOR
	INY		;POINT TO SUBSCRIPT IN LIST
	CMP(VarAdr),Y	;ARE THEY THE SAME?
	BNE NotVar	;BRANCH IF THIS ONE IS NOT IT
	LDA VSub+1	;ARE LOW ORDERS ALSO THE SAME?
	INY
	CMP(VarAdr),Y
	BNE NotVar	;BRANCH IF THEY ARE NOT THE SAME
LOCVAR: JSR FetVar	;GET THE VARIABLE'S VALUE INTO FLAC
	JSR PopJ	;AND RETURN TO CALLER

NOVAR:	LDA StrSwt	;IS THIS STRING A VARIABLE
	BNE @NOSTR	;BRANCH IF IT IS A STRING VARIABLE
	LDA VCHAR	;GET THE VARIABLE'S NAME
	STA (VarAdr),Y	;STORE IT IN LIST
	INY		;POINT TO NEXT IN LIST
	LDA VSub	;GET HIGH ORDER SUBSCRIPT
	STA (VarAdr),Y  ;SAVE IT IN LIST
	INY		;POINT TO NEXT
	LDA VSub+1	;GET LOW ORDER SUBSCRIPT
	STA (VarAdr),Y  ;SAVE IT IN LIST
	LDA #0
	LDX #6		;GET COUNT OF NUMBER OF BYTES IN NUMBER
@ZERVAR: INY		;POINT TO THE NEXT VARIABLE
	STA (VarAdr),Y  ;ZERO OUT VARIABLES VALUE
	DEX		;COUNT THIS BYTE
	BNE @ZERVAR	;LOOP TILL DONE. NOTE: EXTRA ZERO AT END
	LDA #$FF	;FLAG END OF VARIABLE LIST
	STA (VarAdr),Y
	JSR UpdEnd	;UPDATE THE END OF THE VARIABLE LIST
	BNE LOCVAR	;UNCONDITIONAL BRANCH, AS WE HAVE FOUND
			;THE VARIABLE

@NOSTR: ; STRING VARIABLE WAS NOT FOUND
	LDA #StrMrk	;ADD A STRING MARKER AT THE END OF VARIABLE LIST
	STA (VarAdr),Y
	INY
	LDA VCHAR	;ADD IT'S NAME
	STA (VarAdr),Y
	INY
	LDA StrSiz	;GET DEFAULT STRING SIZE
	STA (VarAdr),Y  ;STORE AS SIZE OF STRING
	STA VSize	;ALSO STORE FOR OTHERS WHO NEED TO KNO
	INY		;POINT TO FIRST BYTE OF STRING
	TYA		;UPDATE 'VarAdr'
	JSR UpdVar
	LDY #0		;POINT TO FIRST BYTE OF STRING
	LDA #$20	;GET A BLANK
@STRINI: STA (VarAdr),Y	;SET STRING TO ALL BLANKS
	INY
	CPY StrSiz	;DONE YET?
	BNE @STRINI	;NO, LOOP TILL STRING IS ALL BLANKS
	LDA #$FF	;GET THE END OF VARIABLE LIST MARKER
	STA (VarAdr),Y  ;FLAG END OF LIST
	TYA		;UPDATE 'VarAdr'
	JSR UBDENV
	JMP GETSTC	;GET BYTE FROM STRING AND RETURN


VarIni:	LDA VarBeg+0	;GET ADDR OF Start OF VARIABLE LIST
	STA VarAdr+0	;AND SET POINTER
	LDA VarBeg+1
	STA VarAdr+1
	RTS		;AND RETURN


NxtVar:	LDA #VarSiz	;ADD IN SIZE OF NUMERIC VARIABLE
UpdVar:	CLC		;SETUP FOR ADDITION
	ADC VarAdr	;TO 'VarAdr'
	STA VarAdr
	LDA VarAdr+1
	ADC #0
	STA VarAdr+1
	RTS


UpdEnd: ; UPDATE THE END OF THE VARIABLE LIST
	LDA #VarSiz	;ADD SIZE OF NUMERIC VARIABLE
UBDENV:	CLC
	ADC VarAdr+0	;ADD NUMBER IN ACCUMULATOR 'VarAdr'
	STA VarEnd+0	;AND STORE RESULT IN 'VarEnd'
	LDA VarAdr+1
	ADC #0		;ADD IN THE CARRY
	STA VarEnd+1
BOMSVR:	RTS


BomStV: ; BOMB OUT IF THE VARIABLE IS A STRING VARIABLE
	LDA StrSwt	      ;GET A STRING FLAG
	BEQ BOMSVR	      ;RETURN IF NOT A STRING
	Trap SVNA	      ;?STRING VARIABLE NOT ALLOWED HERE


;	   'VARIABLE MANIPULATION UTILITIES

PutVar: ; PUT NUMBER IN FAc1 INTO THE VARIABLE
	LDY #3		;POINT TO Start OF VALUE
@1:	LDA FAc1-3,Y	;GET A BYTE FROM FAc1
	STA (VarAdr),Y  ;STORE IT INTO VARIABLE
	INY		;POINT TO NEXT BYTE
	CPY #VarSiz	;REACHED END OF VARIABLE YET?
	BNE @1		;NO, THEN MOVE SOME MORE
	RTS		;*** MUST RETURN WITH Z BIT = ! ! ***


FetVar: ; FETCH VARIABLE VALUE INTO FAc1
	LDY #3		;POINT TO Start OF VALUE
@1:	LDA (VarAdr),Y  ;GET A BYTE FROM VARIABLE
	STA FAc1-3,Y	;PUT IT INTO FAc1
	INY		;POINT TO NEXT BATE
	CPY #VarSiz	;REACHED THE END OF VARIABLE YET?
	BNE @1		;NO, THEN MOVE ANOTHER BYTE
	RTS		;YES, RETURN


PushIV: ; PUSH INCREMENT AND VARIABLE ADDR ON STACK USED BY "FOR" COMMAND
	LDX #VarAdr	;POINT TO VARIABLE ADDR
	JSR PushB2	;PUSH IT INTO STACK
	JMP PhFAc2	;* PJMP * PUSH FAc2 INTO STACK AND RETURN


PopIV: ; POP INCREMENT AND VARIABLE ADDR OFF STACK
	JSR PlFAc2	;RESTORE INTO FAc2
	LDX #VarAdr+1	;POINT TO VARIABLE ADDR
	JMP PopB2	;* PJMP * RESTORE INTO VARIABLE ADDR AND RETURN


ZrFAc1: ;ZERO THE FloatING POINT ACCUMULATOR FAc1
	LDX #NumbF-1	;POINT TO LAST BYTE
	LDA #0		;LOAD A ZERO
@2:	STA X1,X	;ZERO THE BYTE
	DEX		;POINT TO NEXT ONE
	BNE @2		;LOOP TILL ALL OF MANTISSA ZEROED
	LDA #$80	;NOW SET EXPONENT
	STA X1
	RTS		;AND RETURN


;	   'INTERRUPT HANDLERS'

NotBrk:	PHA		;SAVE THE ProcesSOR STATUS
	LDA #UnkInt	;UNKNOWN INTERRUPT
	PHA		;SAVE CODE ON STACK
	BNE BError	;AND PRINT ERROR CODE

NmiSrv:	NOP		;CURRENTLY PONT NMI'S AS UNKNOWNS
IntSrv:	STA ACSAV	;SAVE ACCUMULATOR
	PLA		;GET THE ProcesSOR STATUS
	BIT MskBrk	;IS B BIT ON?
	BEQ NotBrk	;BRANCH TO INTERRUPT SERVICE CHAIN
	STA STATUS	;SAVE OLD ProcesSOR STATUS
	PLA		;GET THE LOW ORDER RETURN ADDRESS
	CLC		;GET READY FOR ADD
	ADC #$FF	;ADD IN A -1
	STA ITemp1+0	;STORE IT IN PAGE ZERO
	PLA		;GET HIGH ORDER RETURN ADDR
	ADC #$FF	;ADD IN A -1
	STA ITemp1+1	;STORE IN PAGE ZERO
	TYA		;GET Y REGISTER
	PHA		;  SAVE ON STACK
	LDY #0
	LDA (ITemp1),Y	;GET BRK CODE
	PHA		;  SAVE ON STACK
	BMI BError	;BRANCH IF A SOFTWARE DETECTED ERROR
	PLA		;POSITIVE ERROR CODE, GET IT BACK
	LDA #UnrBrk	;UNRECOGNIZABLE BREAK
	PHA		;SAVE ON STACK

BError: ; ERROR CODE OUTPUT ROUTINE
	LDA #$FF	;GET -1
	STA M1+0	;  FOR HIGH ORDER
	PLA		;GET THE NEG ERROR CODE
	STA M1+1	;  STORE INTO LOW ORDER
	JSR Flt16	;Float IT
	JSR Setup	;RESET AND INITIALIZE IMPORTANT STUFF
	JSR CRLF	;ADVANCE A LINE
	LDA #'?'	; INDICATE AN ERROR
	JSR PrintC
	JSR OutLn0	;OUTPUT IT
	LDA PC+0	;GET HIGH ORDER FOCAL STATEMENT COUNTER
	BPL @1		;BRANCH IF ERROR OCCURED IN A STORED STATEMENT
	CMP #StrLin	;DID ERROR OCCUR WHILE EXECUTING A STRING?
	BNE @C		;NO, THEN ERROR OCCURED IN DIRECT COMMAND
@1:	LDA #$20	;SPACE FOR LookS
	JSR PrintC
	LDA #'@'	;NOW AN '@'
	JSR PrintC
	LDA #$20	;ANOTHER SPACE FOR THE LookS
	JSR PrintC
	JSR PushTP	;SAVE THE TextPOINTERS
	LDA PC+0	;EXECUTING A STRING WHEN ERROR OCCURED?
	BPL @2		;BRANCH IF NOT, PRINT STATEMENT NUMBER
	LDA PC+1	;YES, THEN GET THE STRING NAME
	JSR PrtVNm	;AND PRINT IT
	LDA #'$'	;INDICATE IT'S A STRING
	JSR PrintC
	BNE @3		;AND UNCONDITIONALLY PRESS ON

@2:	LDA #PC		;GET ADDR OF WHERE PROGRAM COUNTER IS STORED
	STA TxtAdr+0	;MAKE TEXT POINTER POINT TO IT
	LDA #0
	STA TxtAdr+1	;HIGH ORDER IS ZERO
	STA TextP
	JSR PrntLn	;OUTPUT THE LINE NUMBER
@3:	JSR PopTP	;RESTORE TEXT POINTERS
			;FALL INTO '@C'

;	   'MORE INTERRUPT HANDLERS'

@C:	JSR CRLF2	;ADVANCE TWO LINES
	LDY #0	 	;POINT TO FIRST CHAR IN LINE
	LDA PC+0	;DIRECT COMMAND OR STRING?
	BMI @OutCmd	;BRANCH IF YES
	LDY #2		;NO, THEN POINT PAST LINE NUMBER
@OutCmd: CPY TextP	;ARE WE AT FRONT OF LINE?
	BEQ @RET	;BRANCH IF YES, DON'T OUTPUT SPECIAL ERROR AID
@OutCmL: TYA		;SAVE Y OUTPUT ACROSS OUTPUT CALL
	PHA
	LDA (TxtAdr),Y	;OUTPUT CHAR FROM COMMAND LINE SO USER CAN SEE
	JSR PrintC
	CMP #$0D	;REACHED END OF LINE YET?
	BEQ @EOL	;BRANCH IF YES,
	PLA		;RESTORE Y REG
	TAY
	INY		;POINT TO THE NEXT CHAR IN THE COMMAND LINE
	BNE @OutCmL	;AND LOOP TILL ALL OF THE COMMAND LINE HAS BEEN OUTPUT
@EOL:	PLA		;ADJUST STACK
	JSR OutLf	;FOLLOW WITH A LINE FEED
@CHKERR: DEC TextP	;COUNT DOWN NUMBER OF BYTES TILL ERROR
	LDY #0		;ASSUME WE COUNT BACK TO ZERO
	LDA PC+0	;DIRECT COMMAND OR STRING
	BMI @CHKERC	;BRANCH IF YES
	LDY #2		;NO, THEN WE ONLY COUNT BACK TO LINE NUMBER
@CHKERC: CPY TextP	;HAVE WE OUTPUT ENOUGH SPACES TO GET ERROR BYTE?
	BEQ @EARROW	;BRANCH IF YES, OUTPUT UPARROW TO FLAG CHARACTER
	LDA #$20	;NO, THEN ADVANCE ONE SPACE
	JSR PrintC
	BPL @CHKERR	;AND UNCONDITIONALLY CHECK AGAIN
@EARROW: LDA #'^'	;OUTPUT UPARROW TO INDICATE WHERE ERROR IS
	JSR PrintC
	JSR CRLF2	;AND ADVANCE FOR LookS
@RET:	JMP Start	;AND Restart


CRLF2:	JSR CRLF	;ADVANCE TWO LINES
CRLF:	LDA #$0D	;A CARRIAGE RETURN
	JSR PrintC
OutLf:	LDA #$0A	;AND A LF
	JMP PrintC	;* PJMP * TO PRINT ROUTINE


GetILN: ; 'INTEGER LINE NUMBER INPUT ROUTINE'
  ;
  ; CALLED IF THE FIRST CHAR OF A LINE NUMBER
  ; IS 0-9 FOR ADDED SPEED, AS THE CALL TO 'EVAL' IS POWERFUL
  ; BUT SLOW (SEE 'GetLn').
  ;
	JSR GETIN	;GET A TWO-DIGIT INTEGER
	STA GrpNo	;SAVE AS GROUP NUMBER
	JSR TTerms	;IS TERMINATOR ONE WE RECOGNIZE?
	BEQ GETIR	;YES, THEN RETURN
	CMP #'.'	;NO, IS IT A PERIOD?
	BNE GETBAD	;NO, THEN A BAD LINE NUMBER
	JSR TestNS	;ANOTHER NUMBER?
	BCS GETBAD	;NO, THEN ERROR
	JSR GETIN	;YES, THEN GET NEXT NUMBER
	BCC @OK		;BRANCH, IF TWO-DIGIT OUTPUT
	TAX		;MOVE INTO X
	LDA Tens,X	;YES, THEN ASSUME TRAILING ZERO
@OK:	STA LineNo	;SAVE THE LINE (STEP) NUMBER
	RTS		;AND RETURN


GETIN:	AND #$0F	;MAKE 0-9
	PHA		;SAVE ON STACK
	JSR TestNS	;TEST NEXT NON-BLANK
	PLA		;RESTORE SAVED NUMBER
	BCS GETIR	;RETURN IF NOT A DIGIT
	TAX		;PLACE SAVED NUMBERINTO X
	LDA CHAR	;GET NEW DIGIT
	AND #$0F	;FORM 0-9
	ADC Tens,X	;ADD IN PROPER HIGH ORDER
	PHA		;SAVE NUMBER ON STACK
	JSR TestNS	;TEST NEXT NON-BLANK
	PLA		;GET SAVED NUMBER BACK
	BCS GETIRC	;BRANCH IF NOT A NUMBER
GETBAD: JMP BadLnO	;BAD LINE NUMBER BRANCH AID

GETIRC:	CLC		;INDICATE TWO DIGITS INPUT
GETIR:	RTS		;RETURN

Tens:	.BYTE 0
	.BYTE 10
	.BYTE 20
	.BYTE 30
	.BYTE 40
	.BYTE 50	    ; Aresco code has a $15 here, clearly wrong
	.BYTE 60
	.BYTE 70
	.BYTE 80
	.BYTE 90



;		FOCAL FUNCTIONS


FUNC: ; call function by Hash code in X
	LDY #0
	TXA		;PLACE Hash CODE INTO ACCUMULATOR
@1:	LDX FunTab,Y	;end of table?
	BEQ @Bad
	CMP FunTab,Y	;Match?
	BEQ @Got
	INY		;TO NEXT ENTRY
	BNE @1		; Unconditional

@Got:	LDA FunAdL,Y	;GET LOW ORDER ADR OF ROUTINE TO HANDLE FUNCTION
	STA Temp1+0
	LDA FunAdH,Y	;GET HIGH ORDER
	STA Temp1+1
	JMP (Temp1)	;AND GO TO IT

@Bad:	Trap UnrFun	;?UNRECOGNIZABLE FUNCTION NAME


FAbs: ; Absolute value function
	JSR AbsF1	     ;TAKE ABSOLUTE VALUE OF FAc1 (vers.4=$2355)
	JMP FPopJ	     ;*PJMP* AND RETURN


;     FInt & FINR - RETURN INTEGER FUNCTIONS

FInt:	JSR IntFix	; MAKE FAc1 AN INTEGER (VERS.4=$5052)
FLPopJ:	JSR Float	; Float ALL BITS
FPopJ:	JSR PopJ	; *FJMP* AND RETURN


FINR: ; INTEGERIZE AFTER ROUNDING
	JSR Intger	; FORM ROUNDED INTEGER
	JMP FLPopJ	;*PJMP*Float AND RETURN


;	       ROUTINES TO CHECK RANGE INPUT AND OUTPUT DEVICE NUMBERS

ChkODv:	CMP #3		;COMPARE AC AGAINST MAX ALLOWED
	BPL RngDev	;BRANCH IF ERROR
ChkRts:	RTS		;RETURN IF OK


ChkIDv:	CMP #3		;COMPARE AGAINST MAX
	BMI ChkRts	;RETURN IF OK
RngDev:	CMP #$FF	;MINUS 1?
	BEQ ChkRts	;BRANCH IF YES, ALWAYS IN RANGE
	Trap DEVRNG	;DEVICE NUMBER OUT OF RANGE


FInI: ; INITIALIZE INPUT DEVICE
	JSR Intger	;MAKE ARGUMENT INTEGER
	BMI InIRet	;IGNORE IF NEGATIVE
	JSR ChkIDv	;CHECK FOR VALIDITY
	JSR INI		;GO CALL APPROPRIATE ROUTINE
InIRet:	JMP FLPopJ	;NO ERRORS, RETURN


FInO: ; INITIALIZE OUTPUT DEVICE
	JSR Intger	;MAKE ARGUMENT AN INTEGER
	BMI InIRet	;IGNORE IF NEGATIVE
	JSR ChkODv	;CHECK FOR VALIDITY
	JSR INO		;GO CALL APPROPRIATE ROUTINE
	JMP FLPopJ	;NO ERRORS - RETURN


FClI: ; CLOSE INPUT DEVICE
	JSR Intger	;MAKE ARGUMENT AN INTEGER
	BMI ClIRet	;IGNORE IF NEGATIVE
	JSR ChkIDv	;RANGE CHECK THE DEVICE NUMBER
	JSR CLI1	;CALL DEVICE DEPENDENT CODE
ClIRet:	JMP FLPopJ	;NO ERRORS - RETURN


FClO: ; CLOSE OUTPUT DEVICE
	JSR Intger	;MAKE ARGUMENT AN INTEGER
	BMI ClIRet	;IGNORE IF NEGATIVE
	JSR ChkODv	;RANGE CHECK THE DEVICE NUMBER
	JSR CLO		;CALL DEVICE DEPENDENT CODE
	JMP FLPopJ	;NO ERRORS - RETURN


FCon: ; SET CONSOLE
	JSR Intger	;MAKE ARGUMENT AN INTEGER
	BMI @RET	;BRANCH IF NEGATIVE
	JSR ChkIDv	;MAKE SURE DEVICE IS IN RANGE FOR BOTH INPUT
	JSR ChkODv	;AND OUTPUT
	STA ConDev	;MAKE IT CURRENT CONSOLE
	JSR ClrDev	;MAKE CURRENT IO DEVICE
	JSR InIDev	;INITIALIZE IT FOR INPUT AND OUTPUT
	JMP FLPopJ	;*PJMP* NO ERRORS - RETURN

@RET:	LDA ConDev	;GET THE DEVICE NUMBER OF CONSOLE
	JSR Flt8	;Float IT
	JMP FPopJ	;*PJMP* AND RETURN


FCur: ; CONSOLE CURSOR ADDRESSING FUNCTION
  ;	   NOTE:     THIS FUNCTION IS DEVICE DEPENDENT, AND IS HERE
  ;		     PRIMARILY BY POPULAR DEMAND. THE FUNCTION HAS
  ;		     TWO ARGUMENTS. THE FIRST IS THE ROW, THE SECOND
  ;		     IS THE COLUMN, OF THE PLACE TO POSITION ON THE CONSOLE
  ;		     DEVICE (USUALLY ASSUMED TO BE CRT).

	JSR FI2Arg	;PICK UP TWO INTEGER ARGS
	JSR ConCur	;*** CALL THE DEVICE DEPENDENT CODE ***
	BCS JOERRO	;BRANCH IF ERROR HAS OCCURED
	JMP FLPopJ	;* PJMP * AND RETURN

;ROUTINES TO DISPATCH TO DEVICE DEPENDENT INITIALIZATION ROUTINE
;ENTER EACH WITH THE DEVICE NUMBER IN THE ACCUMULATOR
;THEY WILL RETURN ONLY IF NO ERRORS WERRE ENCOUNTERED

INI:	TAX		;USE AS OFFSET TO ADDR TABLE
	LDA INIAH,X	;GET HIGH ORDER ADDR OF THE ROUTINE TO HANDLE
	STA Temp1+1	;SAVE IT
	LDA INIAL,X	;GET LOW ORDER ADDR
IniC:	STA Temp1	;SAVE IT
	CLC		;ASSUME SUCCESSS
	JSR JsrInd	;CALL THE PROPER ROUTINE FOR THIS DEVICE
	BCC IRts	;RETURN IF NO ERRORS
	JMP IERRI	;ERROR, GO COMPLAIN
IRts:	RTS

INO:	TAX		;USE AS OFFSET
	LDA INOAH,X	;GET HIGH ORDER OF THE ROUTINE TO HANDLE
	STA Temp1+1	;SAVE IT
	LDA INOAL,X	;GET LOW ORDER OF THE ROUTINE TO HANDLE
INOC:	STA Temp1	;SAVE IT
	CLC		;ASSUME SUCCESS
	JSR JsrInd	;CALL PROPER ROUTINE FOR THIS DEVICE
	BCC IRts	;RETURN IF NO ERRORS
JOERRO:	JMP OERRO	;COMPLAIN IF ERRORS

CLI1:	TAX		;USE AS OFFSET TO TABLE
	LDA CLIAH,X	;GET HIGH ORDER ADDR OF THE DEVICE DEPENDENT CODE
	STA Temp1+1
	LDA CLIAL,X	;GET LOW ORDER ADDR
	JMP IniC	;*PJMP* CALL DEVICE DEPENDENT CODE AND RETURN


CLO:	TAX		;USE AS OFFSET TO TABLE
	LDA CLOAH,X	;GET HIGH ORDER ADDR OF THE DEVICE DEPENDENT CODE
	STA Temp1+1
	LDA CLOAL,X	;GET LOW ODER
	JMP INOC	;*PJMP* CALL DEVICE DEPENDENT CODE AND RETURN


FMem: ; MEMORY EXAMINE-DEPOSIT FUNCTION
	JSR FI2Arg	;PICK UP TWO INTEGER ARGS
	LDY CHAR	;GET THE TERMINATOR
	CPY #','	;ANOTHER ARG?
	BEQ FMemD	;YES, THEN IT'S THE DEPCSIT FUNCTION
	STA ITmp1H	;SAVE HIGH ORDER ARRD TO EXAMINE
	STX ITmp1L	;SAVE THE LOW ORDER ADDR TO EXAMINE
	LDY #0		;FORM OFFSET OF ZERO
	LDA (ITmp1L),Y	;GET DATA STORED IN THE LOCATION
ST16PJ:	STA M1+1	;SAVE IN INTEGER
	STY M1		;HIGH ORDER OF ZERO
FL16PJ:	JSR Flt16	;Float A 16 BIT INTEGER
	JMP FPopJ	;*PJMP* AND RETURN

FMemD:	PHA		;SAVE HIGH ORDER
	TXA
	PHA		;AND LOW ORDER
	JSR NxIArg	;PICK UP THE NEXT INTEGER ARG
	TAY		;SAVE IN Y REGISTER FOR A MOMENT
	PLA		;GET LOW ORDER ADDR BACK
	STA ITmp1L
	PLA		;GET HIGH ORDER ADDR BACK
	STA ITmp1H
	TYA		;GET DATA TO DEPOSIT BACK
	LDY #0
	PHA		;SAVE DATA TO DEPOSIT
	LDA (ITmp1L),Y	;READ THE LOCATION
	STA M1+1	;SAVE AS INTEGER
	STY M1+0	;HIGH ORDER OF ZERO
	PLA		;GET DATA TO DEPOSIT BACK AGAIN
	STA (ITmp1L),Y  ;STORE IN THE ADDR
	LDA CHAR	;GET TERMINATOR
	CMP #','	;MORE ARGS?
	BNE FL16PJ	;* PJMP * NO, Float AND RETURN
	JSR PushJ	;MOVE PAST COMMA,
	  .WORD EvalM1	;EVALUATE NEXT ARG
	JMP FMem	;AND TRY AGAIN


FOut: ; OUTPUT ASCII EQUIVALENT
	JSR Intger	;FORM INTEGER
	JSR PrintC	;OUTPUT THE CHARACTER
	JMP FLPopJ	;* PJMP * Float AND RETURN


FChr: ; RETURN DECIMAL EQUIVALIENT CF ASCII CHAR INPUT
	JSR GICHR	;GET A CHAR FROM INPUT DEVICE
	JMP FL16PJ	;* PJMP * Float AND RETURN


GICHR: ; ROUTINE TO INPUT ONE CHAR FROM INPUT DEVICE INTO FAc1
	LDA #0		;ZERO HIGH ORDER
	STA M1+0
	LDA CHAR	;SAVE CURRENT CHAR
	PHA
	JSR ReadC	;NEXT CHAR FROM INPUT DEVICE
	STA M1+1	;STORE IN LOW ORDER
	PLA		;RESTORE SAVED CHAR
	STA CHAR
	LDA M1+1	;GET CHAR INPUT INTO ACCUMULATOR
	RTS		;AND RETURN


FEch: ; SET CHAR ECHO CONTROL
	JSR Intger	;FORM INTEGER
	STA EchFlg	;SAVE IN FLAG FOR LATER REFERENCE
	JMP FLPopJ	;* PJMP * Float AND RETURN


FIDv: ; SET INPUT DEVICE FUNCTION
	LDX #StIAdr	;GET ADDR TO STORE INTO STRING INFORMATION
	JSR GtDevN	;GET DEVICE NUMBER (POSSIBLY A STRING)
	JSR ChkIDv	;RANGE CHECK IT
	LDX IDev	;SAVE PREVIOUS VALUE FOR POSSIBLE RESTORE
	STX IDvSav
	STA IDev	;MAKE IT THE CURRENT INPUT DEVICE
	JMP FIODRT	;* PJMP * SET FAc1 TO ZERO, THEN RETURN


FODv: ; SET OUTPUT DEVICE FUNCTION
	LDX #StOAdr	;GET SDDR TO STORE STRING INFORMATION
	JSR GtDevN	;GET DEVICE NUMBER (POSSIBLY A STRING)
	JSR ChkODv	;RANGE CHECK IT
	LDX ODev	;SAVE PREVIOUS VALUE FOR POSSIBLE RESTORE
	STX ODvSav
	STA ODev	;SET AS OUTPUT DEVICE
FIODRT:	JSR ZrFAc1	;RETURN A VALUE OF ZERO FOR THE FUNCTION
	JMP FLPopJ	;* PJMP * Float AND RETURN


GtDevN: ; ROUTINE TO GET A DEVICE NUMBER (POSSIBLY A STRING)
	LDA StrSwt	;WAS ARGUMENT A STRING VARIABLE?
	BNE @STR	;BRANCH IF YES
	JMP Intger	;* PJMP * NO, JUST TO INTEGRIZE ARG AND RETURN

@STR:	LDA VarAdr+0	;STORE BASE ADDR OF STRING
	STA 0,X		;IN POINTER
	LDA VarAdr+1
	STA 1,X
	LDA VSub+1	;GET SUBSCRIPT OF PLACE TO Start
	STA 2,X
	LDA VSize	;AND GET MAX SIZE OF STRING
	STA 3,X
	LDA #$FF	;RETURN DEVICE NUMBER OF -1
	RTS


FI2Arg:	LDA CHAR	;GET TERMINATOR
	CMP #','	;',' ANOTHER ARG?
	BNE FARGM	;BRANCH IF ARG IS MISSING
	JSR Intger	;GET A SINGLE BYTE INTEGER
	PHA		;SAVE ACROSS 'EVAL' CALL
	JSR NxIArg	;GET ANOTHER ARG
	TAX		;SAVE THE SECOND ARGUMENT
	PLA		;GET THE FIRST ARGUMENT
	RTS		;AND RETURN

NxIArg:	JSR PushJ	;MOVE PAST COMMA, EVALUATE NEXT ARGUMENT
	  .WORD EvalM1
	JMP Intger	;*PJMP* FORM SINGLE BYTE INTEGER AND RETRUN

FARGM:	Trap ARGM	;?ARGUMENT MISSING IN FUNCTION


Intger: ; ROUTINE TO GENERATE A ROUNDED INTEGER
	LDX #FHalf	;MOVE CONSTANT .50
	LDY #FAc2	;INTO FAc2
	JSR MovXY
	JSR Swap	;PUT .5 IN FAc1
	LDA M2+0  	;GET SIGN OF FAc2
	BPL @1	  	;OK IF POSITIVE
	JSR FCompl	;MAKE -.50
@1:	JSR FAdd	;ADD IT IN AS ROUNDING
IntFix:	JSR FIX		;AND FORM 23 BIT INTEGER
	LDA M1+2	;GET LOW ORDER IF CALLER NEEDS IT
	RTS		;AND RETURN


;	    "FPIC" SOFTWARE PRIORITY INTERRUPT CONTROL FUNCTION
;
FPICC:	JSR PushJ	;CALL 'EVAL' TO PICK UP NEXT ARG
	  .WORD EvalM1
FPIC:	LDA CHAR	;GET CHAR WHICH TERMINATED ARGUMENT
	CMP #','	;IS THERE ANOTHER ARGUMENT TO FOLLOW
	BNE FARGM	;BRANCH IF NOT, GO COMPLAIN
	JSR Intger	;YES, PICK UP VALUE OF FIRST
	BEQ @PISET	;BRANCH IF LEVEL TO ENABLE IS 0
	PHA		;SAVE LEVEL TO ENABLE
	JSR GetC	;MOVE PAST COMMA
	JSR GetLnS	;AND PICK UP THE LINE NUMBER TO 'DO'
	PLA		;GET LEVEL BACK
	TAX		;INTO X REGISTER
	LDA GrpNo	;GET GROUP NUMBER OF LINE TO 'DO'
	STA IntGrp,X	;SAVE FOR LATER USE
	LDA LineNo	;GET STEP NUMBER OF LINE TO 'DO'
	STA IntLin,X	;SAVE FOR LATER USE
	LDA ActMsk	;GET MASK WHICH INDICATES WITH CHANNELS
	ORA BitTab,X	;SET THE BIT FOR SPECIFIED CHANNELS
	STA ActMsk	;MAKING IT ACTIVE NOW
@ENDPIC: LDA CHAR	;GET CHAR WHICH TERMINATES SECOND ARG
	CMP #','	;',' ANY MORE ARGS?
	BEQ FPICC ;L2FAD	;BRANCH IF YES, PICK THEM UP
	LDY #0
	LDA ActMsk	;AND THE CURRENT ACTIVE MASK
	JMP ST16PJ	;* PJMP * STORE, Float AND RETURN IT AS VALUE

@PISET:	JSR NxIArg	;GET NEXT ARG AS NUMBER
	LDA M1+1	;IS IT NEGATIVE
	BMI @ENDPIC	;YES, THEN THIS CALL IS A NO-OP
	LDA M1+2	;NO, GET THE INTEGER VALUE (0-255)
	STA ActMsk	;AND STORE THAT AS NEW ACTIVE MASK
	JMP @ENDPIC	;AND CHECK FOR MORE ARGUMENTS BEFORE RETURNING


;		     'FOCAL STRING FUNCTIONS'

; "FISL" INITIALIZE STRING LENGTH
FISLNX:	JSR PushJ	;PICK UP NEXT ARGUMENT
	 .WORD EvalM1
FISL:	LDA StrSiz	;SAVE DEFAULT STRING SIZE
	PHA
	JSR Intger	;GET FIRST ARGUMENT WHICH IS SIZE TO SET
	STA StrSiz
	JSR FGTSV	;GET NEXT ARGUMENT WHICH IS A STRING VARIABLE
	    ;IF NOT PREVIOUSLY DEFINED IT WILL BE DEFINED
	    ;WITH SUPPLIED LENGTH.
	PLA		;RESTORE WITH LENGTH
	STA StrSiz
	LDA CHAR
	CMP #','	;ANY MORE ARGS?
	BEQ FISLNX
	JMP FPopJ	;* PJMP * NO, THEN RETURN


FGTSV: ; GET A STRING VARIABLE FROM PROGRAM TEXT
	LDA CHAR	;ANY MORE ARGUMENTS IN FUNCTION CALL?
	CMP #','
	BNE FSTRBA	;  BRANCH IF NOT, ERROR
	JSR GetC	;YES, MOVE PAST COMMA
	JSR PushJ	;CALL 'GetVar' TO GET A VARIABLE
	  .WORD GetVar
	LDA StrSwt	;WAS IT A STRING VARIABLE?
	BNE @OK		;  BRANCH IF IT WAS
	Trap SVRQ	;?STRING VARIABLE REQUIRED HERE

@OK:	LDY VSub+1	;GET ELEMENT POSITION
	LDA VarAdr+0	;AND LOW AND
	LDX VarAdr+1	;HIGH ORDER BASE ADDR OF STRING
	RTS

FSTRBA:	Trap BASTRF	;?BAD OR MISSING ARGUMENT IN STRING FUNCTION


FSTI: ; INPUT A STRING FROM INPUT DEVICE

	JSR SETSIO	;PICK UP ARGS
FSTINX:	JSR GICHR	;GET A CHARACTER FROM INPUT DEVICE
	CMP VCHAR	;IS THIS THE TERMINATOR?
	BEQ SENDIO	;YES, THEN THAT'S ALL FOLKS
	LDY VSub+1	;GET SUBSCRIPT TO PLACE CHAR
	CMP #$7F	;IS THE CHARACTER A RUBOUT?
	BEQ RUBSTI	;BRANCH IF YES, SEE IF WE DO SOMETHING
FSTOC:	STA (VarAdr),Y  ;STORE CHAR THERE
	INC VSub+1	;POINT TO NEXT
	INC StrCnt	;COUNT THIS CHARACTER
	DEC StrMax	;REACH MAX ALLOWED?
	BNE FSTINX	;BRANCH IF NOT, INPUT MORE
SENDIO:	LDA #0		;STORE A ZERO IN HIGH ORDER
	STA M1+0
	LDA StrCnt	;GET NUMBER ACTUALLY MOVED
	STA M1+1
	JMP FL16PJ	;* PJMP * Float AND RETURN

RUBSTI: ;HERE IF RUBOUT SEEN DURING A STRING INPUT
	LDX IDev	;IS THE INPUT DEVICE
	CPX ConDev	;THE CONSOLE?
	BNE FSTOC	;BRANCH IF NOT, DON'T DO ANYTHING SPECIAL
	CPY STBSAV	;YES, ARE WE TRYING TO RUBOUT PAST StartING SUBSCRIPT?
	BEQ FSTINX	;BRANCH IF SO, DON'T DO ANYTHING, IGNORE RUBOUT
	LDY EchFlg	;DOES USER WANT CHARACTER ECHOING?
	BNE @C		;BRANCH IF ECHOING DISABLED
	LDY DelSpl	;DO WE DO FANCY CRT STYLE RUBOUTS?
	BEQ @1		;BRANCH IF NOT
	JSR EatTvC	;YES, THEN EAT THE CHAR OFF CRT SCREEN
	BPL @C		;AND DO COMMON THINGS
@1:	LDA #RubChr	;ECHO PLAIN CHAR TO INDICATE A RUBOUT
	JSR PRNTC
@C:	DEC VSub+1	;PACK UP ONE BYTE IN THE STRING
	DEC StrCnt	;DON'T COUNT THE CHARACTER RUBBED OUT
	INC StrMax
	JMP FSTINX	;AND GET NEXT CHARACTER


FSTO: ; OUTPUT A STRING TO OUTPUT DEVICE

	JSR SETSIO	;GET ARGS
@NX:	LDY VSub+1	;GET SUBSCRIPT OF BYTE IN STRING
	LDA(VarAdr),Y	;GET THE BYTE
	CMP VCHAR	;TERMINATOR?
	BEQ SENDIO	;BRANCH IF YES
	JSR PrintC	;OUTPUT IT
	INC VSub+1	;POINT TO NEXT BATE
	INC StrCnt	;COUNT THIS ONE OUTPUR
	DEC StrMax	;OUTPUT MAX YET?
	BNE @NX		;BRANCH IF MORE TO OUTPUT
	BEQ SENDIO	;BRANCH IF WE HAVE HIT LIMIT

SETSIO: ; ROUTINE TO GET ARGS FOR 'FSTI' AND 'FSTD'

	LDA #0
	STA StrCnt	;INIT BYTE COUNT TO ZERO
	JSR Intger	;GET MAX NUMBER OF CHARACTER TO MOVE
	STA StrMax
	JSR FGTSV	;GET THE STRING VARIABLE
	PHA		;SAVE NEAT STUFF RETURNED
	TXA
	PHA
	TYA
	PHA
	LDA CHAR	;IS THE OPTIONAL TERMINATOR ARG SUPPLIED?
	CMP #','
	BEQ @1		;YES, THEN PICK IT UP
	LDA #$FF	;NO, THEN SET IT TO $FF
	BNE @2		;AND ENTER COMMON CODE

@1:	JSR PushJ	;MOVE PAST COMMA, PICK UP NEXT ARG
	  .WORD EvalM1
	JSR Intger	;FORM INTEGER
@2:	STA VCHAR	;SAVE TERMINATION CHARACTER
	PLA		;RESTORE GOOD STUFF
	STA VSub+1
	STA STBSAV	;REMEMBER SUBSCRIPT TO BEGIN I-O TO/FROM
	PLA
	STA VarAdr+1
	PLA
	STA VarAdr
	RTS		;AND RETURN


WStrng: ; WRITE A STRING
	LDY StOPnt		;new line - not in the original
	    ;original code  (appears to be a patch
	    ;WStrng CPY StOMax	  in ProgExch code)
	    ;	  BEQ WSRET
	    ;	  STA (StOAdr),Y
	    ;	  INC StOPnt
	    ;WSRET	PLA
	    ;	  RTS
;		     ; then go on with IOSRET
;
	CPY StOMax		;BEYOND END OF STRING
	BEQ IOSRET		;BRANCH IF YES, IGNORE
	STA (StOAdr),Y		;NO, STORE CHAR IN STRING
	INC StOPnt		;POINT TO NEXT BYTE

IOSRET:	LDA #$0D		;RETURN A CR
	    ;additional line in original:
		    ;STA CHAR ;also in char
	RTS			;AND RETURN


RStrng: ; INPUT FROM A STRING
	LDY StIPnt		;GET POINTER TO NEXT BYTE
	CPY StIMax		;BEYOND END OF STRING?
	BEQ IOSRET		;BRANCH IF YES, RETURN A CARRIAGE RETURN
	LDA (StIAdr),Y		;NO, GET BYTE FROM STRING
	STA CHAR		;SAVE FOR THOSE WHO NEED IT
	INC StIPnt		;AND POINT TO NEXT
	RTS			;AND RETURN


FSLK: ; STRING "Look" FUNCTION

	LDA StrSwt		;WAS ARG A STRING VARIABLE
	BNE @1			;YES, THEN PROCEED
	Trap BASTRF		;?BAD OR MISSING ARGUMENT IN STRING

@1:	LDA VarAdr+0		;COPY POINTERS INTO STRING1 POINTERS
	STA StrAd1+0
	LDA VarAdr+1
	STA StrAd1+1
	LDA VSub+1
	STA SBeg1		;STORE BEGINNING POSITION
	JSR FGTSV		;GET NEXT STRING PARAMETER
	STY SEnd1		;STORE ENDING POSITION
	JSR FGTSV		;GET STRING 2 POINTERS
	STA StrAd2+0
	STX StrAd2+1
	STY SBeg2
	JSR FGTSV		;GET ENDING POSITION
	STY SEnd2		;STORE IT
	LDA #$FF		;ASSUME -1 (STRING NOT FOUND)
	STA M1+0
	STA M1+1

;SEARCH ROUTINE

@LKFChr: JSR CmpChr		;FIRST CHAR MATCH?
	BEQ @FCMAT		;BRANCH IF YES
@CHKEOS: CPY SEnd2		;NO, REACHES END OF STRING2?
	BEQ SNOTF		;BRANCH IF YES, STRING1 NOT FOUND IN STRING2
	INC SBeg2		;NO, POINT TO NEXT CHAR IN STRING2
	JMP @LKFChr		;AND TRY TO FIND CHAR MATCH

@FCMAT: ; HERE IF FIRST CHAR IN STRING1 MATCHES A CHAR IN STRING2
	JSR PushSP		;SAVE CURRENT POSITION IN BOTH STRINGS
@NXCMAT: LDA SBeg1		;REACHED END OF  FIRST STRING?
	CMP SEnd1
	BEQ @FOUND		;BRANCH IF YES, THEN STRING1 WAS FOUND IN STRING2
	CPY SEnd2		;NO, REACHED END OF STRING2?
	BEQ @NOTFP		;BRANCH IF YES, THEN STRING 1 CAN'T BE FOUND IN STRING2
	INC SBeg1		;POINT TO NEXT CHAR IN EACH STRING
	INC SBeg2
	JSR CmpChr		;MATCH?
	BEQ @NXCMAT		;BRANCH IF YES, KEEP CHECKING AS LONG AS THEY MATCH
	JSR PopSP		;NO, THEN RETURN TO THE POINT OF FIRST CHAR MATCH
	JMP @CHKEOS		;AND TRY AGAIN FOR FIRST CHAR MATCH

@FOUND:	JSR PopSP		;RESTORE POINTERS TO POSITION OF FIRST CHAR MATCH
	LDA #0			;STORE 0 IN HIGH ORDER
	STA M1+0
	LDA SBeg2		;RETURN SUBSCRIPT WHERE FIRST CHAR MATCHED
	STA M1+1
	JMP FL16PJ		;* PJMP * Float AND RETURN

@NOTFP:	JSR PopSP		;POP OFF SAVED POINTERS
SNOTF:	JMP FL16PJ		;Float -1 AND RETURN STRING1 WAS NOT FOUND IN STRING2


; ROUTINES USED BY 'FSLK'

CmpChr:	LDY SBeg1	;GET CHAR FROM STRING1
	LDA (StrAd1),Y
	LDY SBeg2	;GET CHAR FROM STRING2
	CMP (StrAd2),Y	;COMPARE THEM
	RTS		;RETURN WITH Z=1 IF THEY ARE THE SAME


PushSP:	TYA		;PRESERVE Y REGISTER
	PHA
	LDX #StrAd1	;SAVE STRING POINTERS ON STACK
	LDY #8
	JSR PushB0
	PLA		;RESTORE Y REGISTER
	TAY
	RTS


PopSP:	TYA		;PRESERVE Y REGISTER
	PHA
	LDX #StrAd1+7	;RESTORE STRING POINTERS
	LDY #8
	JSR PopB0
	PLA		;RESTORE Y REGISTER
	TAY
	RTS


FSBR: ; SINGLE VALUED SUBROUTINE CALL
	JSR GetLn1		;FINISH EVALUATING GROUP OR LINE TO "DO"
	PHP			;SAVE STATUS FLAGS ON STACK
	LDA #$30		;GET CODE NAME FOR VARIABLE '&0'
	STA VCHAR		;SAVE AS VARIABLE NAME TO Look FOR
	LDA #0			;ALSO SET SUBSCRIÜPT TO ZERO
	STA VSub+0
	STA VSub+1
	STA StrSwt		;MAKE SURE STRING VARIABLE FLAG IS OFF
	JSR PushJ		;CALL 'FndVar' TO LOCATE '&0(0)'
	  .WORD FndVar
	JSR Swap		;PUT CURRENT VALUE OF '&0' INTO FAc2
	JSR PushIV		;SAVE IT'S VALUE AND ADDR ON STACK
	LDA CHAR		;GET TERMINATOR
	CMP #','		; IS THERE ANOTHER ARGUMENT
	BEQ @1			;BRANCH IF YES, PRESS ON
	Trap ARGM		;?ARGUMENT MISSING IN FUNCTION

@1:	PLA			;GET FLAGS FROM 'GetLn' INTO ACCUMULATOR
	JSR PushA		;SAVE ON STACK
	LDX #GrpNo		;SAVE LINE OR GROUP TO 'DO'
	JSR PushB2
	JSR PushJ		;MOVE PAST COMMA, EVALUATE NEXT ARGUMENT
	  .WORD EvalM1
	LDX #LineNo		;GET LINE OR GROUP TO 'DO' BACK
	JSR PopB2
	JSR PopA		;GET 'GetLn'FLAGS BACK
	PHA			;SAVE ON STACK FOR LATER
	JSR PopIV		;GET VALUE OF '&0' AND POINTER TO IT
	JSR PushIV		;SAVE FOR LATER (VALUE IS IN FAc2)
	JSR PutVar		;NOW SET '&0' TO ARG VALUE (IN FAc1)
 ;
 ;in original ProgExchange/6502 Group (missing here completely):
 ;lda insw     ;save where input is comming from
 ;jsr PushA	;(program or input device)
 ;lda #$0	   ;and force it to be program
 ;sta insw
 ;
	PLA			;GET STATUS FLAGS RETURNED BY 'GetLn'
	TAX			;SAVE IN X REGISTER
	JSR PushJ		;NOW PERFORM THE 'DO' OF THE LINE OR GROUP
	  .WORD Do1
	JSR PopIV		;RESTORE WHERE INPUT IS COMMING FROM
				;AND OLD VALUE IS IN FAc2
	JSR FetVar		;GET CURRENT VALUE IN FAc1
	JSR Swap		;OLD VALUE IN FAc1, CURRENT VALUE IN FAc2
	JSR PutVar		;REPLACE OLD VALUE OF '&0' BEFORE CALL
	JSR Swap		;GET CURRENT VALUE OF '&0' INTO FAc1
	JMP FPopJ		;RETURN IT AS THE VALUE OF THE 'FSBR'

FRan: ; RANDOM NUMBER GENERATOR,
	; RETURNS A FRACTION BETWEEN 0.00 AND 1.00

	JSR Intger		;INTEGRIZE ARGUMENT
	BEQ @C			;BRANCH IF =0, RETURN NEXT RANDOM NUMBER
	BPL @SET		;BRANCH IF >0, SET TO REPEATABILITY
	LDA Hash		;GET THE RANDOM NUMBER Hash VALUE
	BNE @INI		;AND RANDOMIZE
@SET:	LDA #$55		;SET TO ALTERNATING ZEROS AD ONES
@INI:	LDX #2			;SETUP LOOP COUNTER
@ILP:	STA SEED,X		;STORE IN SEED
	DEX			;POINT TO NEXT
	BPL @ILP		;AND LOOP TILL DONE
@C:	LDA #$7F		;SET EXPONENT OF FAc1
	STA X1
	CLC			;ADD K TO SEED
	LDA SEED
	ADC #$B1
	STA M1+2		;PUT RESULT IN LOW ORDER
	STA SEED		;ALSO THIS PART IN SEED
	LDA SEED+1
	ADC #$0C
	STA M1+1		;INTO MIDDLE ORDER
	LDA SEED+2
	ADC #$1B
	AND #$7F		;KILL SIGN BIT
	STA M1
	LDA M1+2
	ASL A			;2^17
	CLC
	ADC M1+2		;2^16
	CLC
	ADC M1			;PLUS HIGH ORDER
	STA SEED+2		;NEW SEED
	CLC
	LDA M1+2		;2^8 ADDED
	ADC M1+1
	STA SEED+1
	LDA M1+1
	ADC SEED+2
	STA SEED+2		;SEED NOW READY FOR NEXT TIME
	LDA #0
	JSR NORM0		;NORMALIZE THE FRACTION
	JMP FPopJ		;* pjmp * and return
;
;  in the original here are Floating point package definitions...    ***
;  1 BYTE EXPONENT, 4 BYTE MANTISSA (APPROX 9 SIG FIGS)
	 ;.DEF	SPACE=%40
	 ;.DEF	RUB=%177
	 ;.DEF	CR=%15
	 ;.DEF	LF=%12


;	     CENTRAL ROUTINES

ADD:	CLC
	LDX #3		;*INDEX FOR 4 BYTE ADD
@1:	LDA M1,X
	ADC M2,X	;ADD NEXT BYTE
	STA M1,X
	DEX		;TO NEXT MORE SIG BYTE
	BPL @1		;DO ALL THREE
	RTS


MD1:	ASL SIGN	;CLEAR LSB OF SIGN
	JSR @2		;ABS VAL M1, THEN Swap
@2:	BIT M1+0	;M1 NEG?
	BPL @1		;NO JUST Swap
	JSR FCompl	;YES, NEGATE IT
	INC SIGN	;COMPLEMENT SIGN
@1:	SEC		;FOR RETURN TO MUL/DIV

Swap: ; Swap FAc1 WITH FAc2
	LDX #5		;*FIVE BYTES TOTAL
@1:	STY E-1,X	; LEAVE shifted COPY
	LDA FAc1-1,X	; Swap A BYTE OF FAc1 WITH FAc2
	LDY FAc2-1,X
	STY FAc1-1,X
	STA FAc2-1,X
	DEX		;NEXT BYTE
	BNE @1		;UNTIL DONE
	RTS


Float: ; Float 23 BITS OF MANTISSA
	LDA #$80+22	;SET EXPONENT TO 22 DECIMAL
	STA X1
	LDA #0		;ZERO INTO LOW BYTES
	BEQ NORM0	;* PBE Q* NORMALIZE IT AND RETURN


Flt8: ; DO A FAST Float OF A 1-BYTE QUANTITY
	STA M1+0	;STORE THE BYTE
	LDA #$80+6	;ASSUME ALREADY SHIFTED 8 BLACES
	STA X1
	LDA #0		;GET A ZERO
	STA M1+1	;ZERO OUT BYTE OF MANTISSA
	BEQ FloatC	;*P BEQ * CLEAR THIRD BYTE, NORMALIZE AND RETURN


Flt16: ; Float A 16-BUT INTEGER IN M1+0 & M1+1 TO FAc1
	; FAc2 UNAFFECTED

	LDA #$80+14
	STA X1		;SET EXP TO 14 DEC
	LDA #0		;CLEAR LOW BYTES
FloatC:	STA M1+2
NORM0:	STA M1+3
			;* PFALL * NORMALIZE IT AND RETURN

NORM: ; Normalize FAc1
	JSR ChkZer	;IS MANTISSA ZERO?
	BNE @L		;  DO THE NORMALIZE SHIFTING
	LDA #$80	;just set corresponding exponent
	STA X1
	RTS

@1:	DEC X1
	ASL M1+3	;shift mantissa left
	ROL M1+2
	ROL M1+1
	ROL M1+0
@L:	LDA M1+0	;normalized (upper 2 bits uneequal)?
	ASL A
	EOR M1+0
	BPL @1		;  LOOP TILL THEY ARE
	RTS


FSub: ;FAc2-FAc1 INTO FAc1
	;original JSR FCompl is missing!!!!!!!!
	JSR FCompl
SwpAlg:	JSR AlgnSw

FAdd: ;FAc1 + FAc2 INTO FAc1
	LDA X2
	CMP X1		;EXPONENTS EQUAL?
	BNE SwpAlg	;IF NOT Swap OR ALIGN
	JSR ADD		;ADD MANTISSAS
AddEnd:	BVC NORM	;IF COOL, NORMALIZE
	BVS RTLOG	;DV: SHIFT RIGHT-CARRY IS COOL
			;Swap IF CARRY CLEAR, ELSE SHIFT RIGHT ARITHMETICALLY


AlgnSw:	BCC Swap
RTAR:	LDA M1		;SIGN INTO CARRY
	ASL A		;ARITH SHIFT
RTLOG:	INC X1		;COMPENSATE FOR SHIFT
	BEQ OVFL	;EXP OUT OF RANGE
RTLOG1:	LDX #$F8	;INDEX FOR 8 BYTE RT SHIFT of M1 & E
@1:	LDA #$80
	BCS @2
	ASL A
@2:	LSR E+4,X	;simulate ROR
	ORA E+4,X
	STA E+4,X
	INX		;NEXT BYTE
	BNE @1		;UNTIL DONE
	.assert M1+4=E, error, "E must extend M1"
	RTS


FMul: ; FAc1 * FAc2 INTO FAc1
	JSR MD1		;ABS VAL OF M1,M2
	ADC X1		;ADD EXPONENTS
	JSR MD2		;CHECK & PREP FOR NUL
	CLC
@1:	JSR RTLOG1	;SHIFT PROD AND MFYR(?) RIGHT
	BCC @2		;SKIP PARTIAL PROD
	JSR ADD		;ADD IN MCAND
@2:	DEY		;NEXT ITERATION
	BPL @1		;LOOP UNTIL DONE
MDEND:	LSR SIGN	;SIGN EVEN OR ODD?
NORMX:	BCC NORM	;IF EVEN NORMALIZE, ELSE COMPARE

FCompl: ; complement FAc1 mantissa
	SEC
	LDX #4		;*4 BYTE SUBTRACT
@1:	LDA #0
	SBC M1-1,X
	STA M1-1,X
	DEX		;TO MORE SIG BYTE
	BNE @1		;UNTIL DONE
	BEQ AddEnd	;FIX UP


OVCHK:	BPL MD3		;IF POSITIVE EXPONENT NO CVF
OVFL:	Trap FOVFL	;FloatING POINT OVERFLOW


FDiv: ; DIVIDE FAc2 BY FAc1 INTO FAc1

	JSR MD1		;ABS VALUE OF M1, M2
	SBC X1		;SUBTRACT EXPONENTS
	JSR MD2		;SAVE AS RES EXP
@1:	SEC
	LDX #3		;* FOR 4 BYTES
@2:	LDA M2,X
	SBC E,X		;SUBTRACT BYTE OF E FROM M2
	PHA
	DEX		;NEXT MORE SIG BYTE
	BPL @2		;UNTIL DONE
	LDX #$FC	;* FOR 4 BYTE COND MOVE
@3:	PLA		;DIFF WAS ON STACK
	BCC @4		;IF M2<E DON'T RESTORE
	STA X1,X	;*
@4:	INX		;NEXT LESS SIG BYTE
	BNE @3		;UNTIL DONE
	ROL M1+3	;*
	ROL M1+2
	ROL M1+1	;ROLL QUOTIENT LEFT
	ROL M1+0	;CARRY INTO LSB
	ASL M2+3	;*
	ROL M2+2
	ROL M2+1	;DIVIDEND LEFT
	ROL M2+0
	BCS OVFL	;OVF IS DUE TO UNNORM DIVISOR
	DEY		;NEXT ITERATION
	BNE @1		;UNTIL DONE (23 ITERATIONS)
	BEQ MDEND	;NORM QUOTIENT AND FIX SIGN

MD2:	STX M1+3	;*
	STX M1+2
	STX M1+1	;CLEAR M1
	STX M1+0
	BCS OVCHK	;CHECK FOR OVFL
	BMI MD3		;IF NEG NO UNDERFLOW
	PLA		;POP ONE RETURN
	PLA
	BCC NORMX	;CLEAR X1 AND RETURN
MD3:	EOR #$80	;COMPL. SIGN OF EXPONENT
	STA X1
	LDY #$1F	;COUNT FOR 31 (/), 32 (*) ITERATIONS
	RTS


; FAc1 TO 23 BIT SIGNED INTEGER IN M1+0 (HIGH), M1+1 (MIDDLE), M1+2 (LOW)
;
FIX1:	JSR RTAR	;SHIFT MANTISSA, INC EXPONENT
FIX:	LDA X1		;CHECK EXP
	CMP #$80+22	;IS EXP #22?
	BNE FIX1	;NO, SHIFT MORE
	RTS


FPrnt: ; FloatING POINT OUTPUT

	LDA M1+0	;SAVE THE SIGN OF THE NUMBER
	STA SIGNP	;FOR LATER REFERENCE
	JSR AbsF1	;DEAL ONLY WITH ABSOLUTE VALUE
	JSR ChkZer	;IS NUMBER = 0?
	BNE @0		;  BRANCH IF NOT, THEN TRY TO DIVIDE DOWN
	STA K		;SOME FLAVOR OF ZERO. INDICATE THAT WE
	PHA		;DID NOT HAVE TO DIVIDE AS ALREADY <1
	BEQ @4A		;  AND PUNT DIVIDE DOWN AND ROUNDING CODE
@0:	LDA X1		;GET THE EXPONENT
	PHA		;SAVE FOR LATER REFERENCE
	LDA #0		;ZERO COUNTER WHICH COUNTS HOW MANY TIMES
	STA K		;  WE HAD TO DIVIDE TO GET NUMBER <1
@1:	BIT X1		;IS NUMBER <1?
	BPL @2		;  BRANCH IF YES
	JSR Div10	;DIVIDE BY 10
	INC K		;COUNT THE FACT WE DID
	BPL @1		;AND CHECK AGAIN

@2:	JSR PhFAc1	;SAVE NUMBER (NOW <1) ON STACK
	LDX #FHalf	;GET THE CONSTANT .5
	LDY #FAc1	;INTO FAc1
	JSR MovXY
	CLC
	LDA K		;ROUNDING FACTOR IS .5*10^-(K+N)
	ADC N
	STA L
	BEQ @4		;BRANCH IF WE NEED .5*10^0
	LDA #9		;* IS FACTOR BEYOND OUR PRECISION?
	CMP L
	BPL @3		;BRANCH IF NOT, THEN ROUNDING FACTOR IS OK
	STA L		;YES, THEN APPLY ROUNDING TO LEAST SIG FIG
@3:	JSR Div10	;NOW SHIFT .5 INTO PROPER POSITION
	DEC L
	BNE @3
@4:	JSR PlFAc2	;GET NUMBER INTO FAc2
	JSR FAdd	;ADD THE ROUNDING FACTOR
	BIT X1		;IS IT STILL <1?
	BPL @4A		;  BRANCH IF IT IS

;original ProgExch/6502Grp code has more lines here:
;     pla	   ;no then get original exponent
;     bmi @4a	    ;branch if original number >1 do nothing
;     lda x1	      ;we gained a sig fig in rounding, get new exp
;@41:	   pha		;save exponent for later
;
	JSR Div10	;SCALE NUMBER BACK DOWN
	INC K		;AND INDICATE WE HAD TO
@4A:	SEC
	LDA M		;Compute number of leading blanks needed
	SBC K
	STA L		;  INTO L
	PLA		;GET EXPONENT OF ORIGINAL NUMBER BACK
	PHA		;SAVE AGAIN FOR LATER
	BMI @4B		;BRANCH IF ORIGINAL NUMBER IS <1?
	DEC L		;IT WAS <1. LEAVE ROOM FOR LEADINF 0
@4B:	BIT SIGNP	;WAS NUMBER NEGATIVE
	BPL @5		;  BRANCH IF NOT
	DEC L		;LEAVE ROOM FOR A MINUS SIGN
@5:	LDA L		;ANY BLANKS TO OUTPUT?
	BMI @7		;BRANCH IF NOT
	BEQ @7		;BRANCH IF NOT
@6:	JSR PSpace	;OUTPUT A BLANK
	DEC L		;COUNT IT
	BNE @6		;AND LOOP TILL ALL HAVE BENN OUTPUT
@7:	BIT SIGNP	;WAS NUMBER NEGATIVE?
	BPL @7A		;BRANCH IF NOT
	LDA #'-'	;YES, OUTPUT A LEADING "-"
	JSR PrintC	;AND FALL INTO NEXT PAGE
@7A:	PLA		;GET EXPONENT OF THE ORIGINAL NUM BACK AGAIN
	BMI @8		;BRANCH IF NOT <1
	JSR PZero	;YES, THEN GIVE A LEADING ZERO
			;(PEOPLE LIKE IT!)
			;(IT'S ALSO A PAIN TO CHECK FOR!)

; NOW FOR THE MEAT OF IT
;
@8:	LDA #9		;* GET MAX NUMBER OF SIG FIGS
	STA L		;  INTO L
	LDA K		;ANY OUTPUT BEFORE DECIMAL?
	BEQ @11		;BRANCH IF NO MORE
@10:	JSR MDO		;OUTPUT A DIGIT BEFORE DECIMAL
	DEC K
	BNE @10		;AND Look TILL ALL DONE
@11:	LDA N		;GET NUMBER AFTER DECIMAL POINT
	STA K		;INTO K
	BEQ @RET	;BRANCH IF NONE TO OUTPUT
	LDA #'.'	;THERE ARE SOME TO OUTPUT,
	JSR PrintC	;PRINT THE DECIMAL POINT
@12:	JSR MDO		;OUTPUT A DIGIT AFTER DECIMAL
	DEC K		;AND LOOP
	BNE @12		;TILL ALL OUTPUT
@RET:	RTS		 ;RETURN FROM 'FPrnt' FAc1 IS DESTROYED!


MDO: ; MPY BY 10, PRINT INTEGER AND SUBTRACT IT
	DEC L		;HAVE WE OUTPUT ALL DIGITS OF SIGNIFICANCE?
	BPL MDo1	;BRANCH IF NOT, OUTPUT THIS ONE
PZero:	LDA #'0'	;OUTPUT A ZERO
	JMP PrintC	;* PJMP * AND RETURN

MDo1:	LDX #FTen	; multiply by 10
	LDY #FAc2
	JSR MovXY
	JSR FMul
	LDX #FAc1	;SAVE FAc1 to T
	LDY #T
	JSR MovXY
	JSR FIX		; cvt to integer
	LDA M1+2	;MAKE ASCII
	AND #$0F
	ORA #$30
	JSR PrintC
	JSR Float	;NOW SUBTRACT IT
	LDX #T		;RESTORE TO FAc2
	LDY #FAc2
	JSR MovXY
	JMP FSub	; a different JMP here in the original!!!!
			;original JMP FSub --na


;   UTILITIES FOR FPrnt

AbsF1: ; absolute value
	BIT M1+0
	BPL @FE
	JSR FCompl
@FE:	RTS


MovXY: ; move Float from zpage,x to zpage,y
	DEX
	STX @1+1
	DEY
	STY @2+1
	LDX #5
@1:	LDA 0,X		; modified
@2:	STA 0,X		; modified
	DEX
	BNE @1
	RTS


Div10: ; divide by 10
	JSR Swap
	LDX #FTen
	LDY #FAc1
	JSR MovXY
	JMP FDiv		;*PJMP*


ChkZer: ; mantissa=0?
	LDA M1+0		;GET HIGH ORDER MANTISSA
	ORA M1+1		;'OR' ALL BYTES OF MANTISSA TOGETHER
	ORA M1+2
	ORA M1+3
	RTS			;RETURN WITH Z=1 IF MANTISSA IS =0.


FInp: ; FloatING POINT INPUT
	LDA #0
	STA SIGNP		;SET SIGN +
	STA DpFlg		;RESET DP FLAG
	STA GotFlg		;NO INPUT YET
	STA K			;NO DIGITS AFTER DECIMAL POINT
	STA X2			;ZERO RESULT
	STA M2+0
	STA M2+1
	STA M2+2
	STA M2+3
	LDA CHAR		;GET CHARACTER
	CMP #'+'		;IGNORE +'S
	BEQ @3
	CMP #'-'		; FLAG IF NEGATIVE
	BNE @2
	INC SIGNP
@3:	JSR GetC		;ANOTHER CHAR
@2:	CMP #'0'		; IS IT A DIGIT?
	BCC @4			;NO
	CMP #'9'+1
	BCS @4			;NO
	LDX #FTen
	LDY #FAc1
	JSR MovXY		;FAc2*10.0=FAc1
	JSR FMul
	JSR Swap		;INTO FAc2
	INC GotFlg		;YES, WE HAVE INPUT
	LDA CHAR
	AND #$0F		;MAKE NUMERIC
	JSR Flt8		;AND Float IT
	JSR FAdd		;ADD TO PARTIAL RESULT
	JSR Swap		;BACK INTO FAc2
	INC K			;COUNT DIGITS AFTER DECIMAL POINT
	BNE @3			;GET MORE
@4:	CMP #'.'		;DECIMAL POINT?
	BNE @5			;NO, END OF #
	LDA DpFlg		;YES, ALREADY GOT ONE?
	BNE @5			;THEN END OF #
	INC DpFlg		;ELSE FLAG GOT ONE
	LDA #0
	STA K			;RESET K
	BEQ @3			;AND GET FRACTION

@5: ; END OF NUMBER
	JSR Swap		;RESULT TO FAc1
	LDA DpFlg		;ANY DECIMAL POINTS?
	BEQ @6			;NO, ITS OK
@7:	LDA K			;ELSE ADJUST
	BEQ @6			;ADJUST DONE
	JSR Div10		;RESULT/10
	DEC K			;K TIMES
	BNE @7
@6:	LDA SIGNP		;NOW ADD SIGN
	BEQ @8			;WAS POS
	JSR FCompl		;WAS NEG
@8:	JMP NORM		;PJUMP TO NORMALIZE

; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;
;      Here begins (again) code restoration by dhh
;
; XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX
;
; from here, the Aresco version of V3D code (TTY) completely differs from
; the ProgramExchange/6502 Group TIM-monitor code upon which it is based.
; PE code occupies $24A6 to $24D0 (here $349E to $34E7), and seems to be
; related to video terminal output.  What follows here are KIM-1-specific
; initialization and I/O routines.  -dhh
;

L349E: ; init console output
	LDA #<IntSrv	; set IRQ vector
	STA $FFFE	; lightly patched for non-KIM-1 hardware
	LDA #>IntSrv
	STA $FFFF
	CLC
	RTS


L34AA: ; console output char
	JSR OutCh	; OUTCH in KIM-1 ROM
	CLC
	RTS


L34AF: ; console input char
	; lightly patched to work around missing KIM-1 hardware
	; Same # of bytes used so later addresses match the .bin file
	INC Hash	; spin the random value
	BIT $1740	; (R)RIOT I/O register A
	BMI *+2 ;L34AF
	LDA $1742	; (R)RIOT I/O register B
	AND #$FE
	lda $1742 ;STA $1742
	JSR GetCh	; GetCH in KIM-1 ROM
	PHA
	LDA $1742	; the KIM-1 echo defeat
	AND #$FE
	ORA #$01
	lda $1742 ;STA $1742
	PLA
	CLC
	RTS


;  The next bytes do not appear to be used for anything.
;  Perhaps leftover from Aresco conversion of Prog/Exch
;  version for KIM-1 (???).
;  unused, left in so following addresses match the .bin file
		.BYTE $00,$43,$11,$51,$11,$11,$17,$01,$01,$11,$41
		.BYTE $53,$01,$51,$51,$11,$53,$EE,$CE,$FE,$EE,$EA
		.BYTE $EE,$06,$FE
;	   .byte 0
;	   ???		      ;01000011 'C'
;	   ORA ($51),Y
;	   ORA ($11),Y
;	   ???		      ;00010111
;	   ORA ($01,X)
;	   ORA ($41),Y
;	   ???		      ;01010011 'S'
;	   ORA ($51,X)
;	   EOR ($11),Y
;	   ???		      ;01010011 'S'
;	   INC $FECE
;	   INC $EEEA
;	   ASL $FE
;

TrmTab: ; SPECIAL TERMINATOR CHAR TABLE (see P/E code at $2401)
	 .BYTE $20	; LEVEL 0 (SPACE)
	 .BYTE '+'	; LEVEL 1 '+'
	 .BYTE '-'	; LEVEL 2 '-'
	 .BYTE '/'	; LEVEL 3 '/'
	 .BYTE '*'	; LEVEL 4 '*'
	 .BYTE '^'	; LEVEL 5 '^'
	 .BYTE '('	; LEVEL 6 '('
	 .BYTE ')'	; LEVEL 7 ')'  (Start OF DELIMITERS)
	 .BYTE ','	; LEVEL 8 ','
	 .BYTE ';'	; LEVEL 9 ';'
	 .BYTE $0D	; LEVEL 10 'CR'
	 .BYTE '='	; LEVEL 11 '=' (TERMINATOR FOR 'SET')
	 .BYTE LinChr	; LEVEL 1 '_'  ('LINE-DELETE IS HERE SO 'ASK' CAN ALLOW RE-TYPEIN)
TrMax = *-TrmTab-1


;      THESE FUNCTION DISPATCH TABLES MAY BE PATCHED BY A USER
;      TO CALL HIS OWN FUNCTIONS.

FunTab: ; TABLE OF 'Hash codes' FOR FUNCTION NAMES
	.BYTE $36	;FAbs ABSOLUTE VALUE
	.BYTE $F4	;FOut CHARACTER OUTPUT
	.BYTE $B0	;FRan RANDOM NUMBER
	.BYTE $A8	;FInt INTEGERIZE
	.BYTE $A4	;FInr INTEGERIZE WITH ROUNDING
	.BYTE $84	;FIDv SET INPUT DEVICE
	.BYTE $B4	;FODv SET OUTPUT DEVICE
	.BYTE $5C	;FChr SINGLE ALPHA CHAR INPUT
	.BYTE $90	;FCur CONSOLE CURSOR ADDRESSING
	.BYTE $44	;FEch ECHO CONTROL
	.BYTE $AA	;FPic SOFTWARE PRIORITY INTERRUPT
	.BYTE $96	;FMem MEMORY EXAMINE-DEPOSIT
	.BYTE $92	;FInI INITIALIZE INPUT DEVICE
	.BYTE $9E	;FInO INITIALIZE OUTPUT DEVICE
	.BYTE $5A	;FClI CLOSE INPUT DEVICE
	.BYTE $66	;FClO CLOSE OUTPUT DEVICE
	.BYTE $70 ;??$73	;FCon SET CONSOLE DEVICE
	.BYTE $C4	;FSBR 'SUBROUTINE' CALL
	.BYTE $AC	;FISL INITIALIZE STRING LENGTH
	.BYTE $FA	;FSTI STRING INPUT
	.BYTE $06	;FSTO STRING OUTPUT
	.BYTE $DE	;FSLK STRING "Look"
	.byte 0,0,0,0,0	; SPARE LOCS FOR HACKERS
	.byte 0		; MUST HAVE AT LEAST ONE ZERO TO END TABLE!

FunAdH: ; FUNCTION DISPATCH TABLES - HIGH BYTE
	.BYTE	>FAbs	,>FOut	,>FRan	,>FInt	,>FINR	,>FIDv	,>FODv	,>FChr
	.BYTE	>FCur	,>FEch	,>FPIC	,>FMem	,>FInI	,>FInO	,>FClI	,>FClO
	.BYTE	>FCon	,>FSBR	,>FISL	,>FSTI	,>FSTO	,>FSLK
	.byte 0,0,0,0,0	; SPACE FOR HACKERS
	.byte 0		; unused

FunAdL: ; FUNCTION DISPATCH TABLES - LOW ORDER ADDR BYTE
	.BYTE	<FAbs	,<FOut	,<FRan	,<FInt	,<FINR	,<FIDv	,<FODv	,<FChr
	.BYTE	<FCur	,<FEch	,<FPIC	,<FMem	,<FInI	,<FInO	,<FClI	,<FClO
	.BYTE	<FCon	,<FSBR	,<FISL	,<FSTI	,<FSTO	,<FSLK
	.byte 0,0,0,0,0	; SPACE FOR HACKERS
	.byte 0		; unused


;     COMMAND DISPATCH TABLES
;
;     THESE COMMAND DISPATCH TABLES MAY BE PATCHED BY USER
;     TO ADD HIS OWN SPECIAL COMMAND HANDLERS

ComTab: ; COMMAND CHARACTER TABLE
	.BYTE 'S'	; SET
	.BYTE 'I'	; IF
	.BYTE 'D'	; DO
	.BYTE 'O'	; ON
	.BYTE 'G'	; GOTO
	.BYTE 'F'	; FOR
	.BYTE 'R'	; RETURN
	.BYTE 'T'	; TYPE
	.BYTE 'A'	; ASK
	.BYTE 'C'	; COMMENT
	.BYTE 'E'	; ERASE
	.BYTE 'W'	; WRITE
	.BYTE 'M'	; MODIFY
	.BYTE 'Q'	; QUIT
	.byte 0,0,0,0	; SPACE FOR HACKERS
	.byte 0		; MUST HAVE ONE ZERO TO END TABLE!
	.byte 0		; unused

ComAdH: ; HIGH ORDER ADDR OF COMMAND HANDLING ROUTINE
	.BYTE >SET	; SET
	.BYTE >IF	; IF
	.BYTE >DO	; DO
	.BYTE >ON	; ON
	.BYTE >GOTO	; GOTO
	.BYTE >FOR	; FOR
	.BYTE >RETURN	; RETURN
	.BYTE >TYPE	; TYPE
	.BYTE >TYPE	; ASK
	.BYTE >PC1	; COMMENT
	.BYTE >ERASE	; ERASE
	.BYTE >WRITE	; WRITE
	.BYTE >MODIFY	; MODIFY
	.BYTE >QUIT	; QUIT
	.byte 0,0,0,0	; SPACE FOR HACKERS

ComAdL : ; LOW ORDER ADDR OF COMMAND HANDLING ROUTINE
	.BYTE <SET	; SET
	.BYTE <IF	; IF
	.BYTE <DO	; DO
	.BYTE <ON	; ON
	.BYTE <GOTO	; GOTO
	.BYTE <FOR	; FOR
	.BYTE <RETURN	; RETURN
	.BYTE <TYPE	; TYPE
	.BYTE <TYPE	; ASK
	.BYTE <PC1	; COMMENT
	.BYTE <ERASE	; ERASE
	.BYTE <WRITE	; WRITE
	.BYTE <MODIFY	; MODIFY
	.BYTE <QUIT	; QUIT
	.byte 0,0,0,0	; SPACE FOR HACKERS


;     DISPATCH TABLE FOR 'EVBOP' ROUTINE
;
; two definitions here in the Prog/Exch code:
; at $2569 (3580 here) .DEF EVDSPH=.-1	and
; $256E (3585) .DEF EVDSPL=.-1

EVDSPH: ; hi byte
	.BYTE >FAdd ;$32	 ; FAdd
	.BYTE >FSub ;$32	 ; FSub
	.BYTE >FDiv ;$32	 ; FDiv
	.BYTE >FMul ;$32	 ; FMul
	.BYTE >EvPowr ;$2A	 ; EvPowr

EVDSPL: ; lo byte
	.BYTE <FAdd ;$79	 ; FAdd
	.BYTE <FSub ;$73	 ; FSub
	.BYTE <FDiv ;$CA	 ; FDiv
	.BYTE <FMul ;$A0	 ; FMul
	.BYTE <EvPowr ;$F7	 ; EvPowr

;	   TABLES USED BY SOFTWARE INTERRUPT SYSTEM

IntGrp: ; TABLE OF GROUP NUMBERS OF LINES TO 'DO' WHEN EVENT HAPPENS
	; ONE ENTRY FOR EACH OF THE 8 PRIORITY CHANNELS
	.byte 0,0,0,0,0,0,0,0
	.byte 0

IntLin: ; TABLE OF STEP NUMBERS OF LINES TO 'DO' WHEN AN EVENT HAPPENS
	.byte 0,0,0,0,0,0,0,0
	.byte 0

IntTab: ; 'AND' MASKS USED TO DISABLE ALL BUT HIGHER PRIO CHANNELS.
	; INDEXED BY CURRENT CHANNEL NUMBER
	.BYTE $FF	; CHANNEL 0 ENABLES THEM ALL
	.BYTE $FE,$FC,$F8,$F0,$E0,$C0,$80
	.BYTE $00	; CHANNEL 8 ENABLES NONE

BitTab: ; BIT TABLE CONTAINING A SINGLE BIT FOR EACH CHANNEL POSITION
	.byte 0,$01,$02,$04,$08,$10,$20,$40,$80


;     DISPATCH TABLE BY I/O DEVICE NUMBERS
;
; handwritten note in P/E source: "READ/WRITE"
; Two definitions made here:
;     .DEF IDEWVM=3	.DEF ODevM=3  ; MAX # OF I/O DEVICES

IDSPH: ; input hi byte
	.BYTE >L34AF	; DEVICE 0 - KEYBOARD INPUT ROUTINE
	.byte 0		; DEVICE 1 - CASSETTE #0 INPUT ROUTINE
	.byte 0		; DEVICE 2 - CASSETTE #1 INPUT ROUTINE
	.byte 0		; SPACE FOR HACKERS
	.byte 0

IDSPL: ; input lo byte
	.BYTE <L34AF
	.byte 0
	.byte 0
	.byte 0
	.byte 0

ODSPH: ; output hi byte
	.BYTE >L34AA	; DEVICE 0 - TV OUTPUT ROUTINE
	.byte 0		; DEVICE 1 - CASSETTE #0 OUTPUT ROUTINE
	.byte 0		; DEVICE 2 - CASSETTE #1 OUTPUT ROUTINE
	.byte 0		; SPACE FOR HACKERS
	.byte 0

ODSPL: ; output lo byte
	.BYTE <L34AA
	.byte 0
	.byte 0
	.byte 0
	.byte 0

; using CA65 goodies:
;	.define ODSP L34AA,0,0,0,0
;ODSPH:	.hibytes ODSP
;ODSPL:	.lobytes ODSP

; handwritten note in P/E source: "INITIALIZE IN/OUT"

INIAH: ; initialize input hi byte
	.BYTE >Rts1	; DON'T NEED TO INTIALIZE KEYBOARD
	.BYTE >Rts1	; USER MUST PROVIDE ROUTINE
	.BYTE >Rts1
	.byte 0,0	; SPACE FOR HACKERS

INIAL: ; initialize input lo byte
	.BYTE <Rts1
	.byte <Rts1
	.byte <Rts1
	.byte 0,0

INOAH: ; initialize output hi byte
	.BYTE >L349E	; USE TO STUFF VECTORS WITH BREAK HANDLERS
	.BYTE >Rts1	; USER PROVIDES ROUTINES
	.BYTE >Rts1
	.byte 0,0

INOAL: ; initialize output lo byte
	.BYTE <L349E
	.byte <Rts1
	.byte <Rts1
	.byte 0,0

; handwritten note in P/E source: "CLOSE IN/OUT"

CLIAH: ; close input hi byte
	.BYTE >Rts1	; KEYBOARD DOESN'T NEED A CLOSE ROUTINE
	.BYTE >Rts1	; USER PROVIDES ROUTINE
	.BYTE >Rts1	;
	.BYTE 0,0	; SPACE FOR HACKERS

CLIAL: ; close input lo byte
	.BYTE <Rts1
	.byte <Rts1
	.byte <Rts1
	.byte 0,0

CLOAH: ; close output hi byte
	.BYTE >Rts1	; TV DOESN'T NEED A CLOSE ROUTINE
	.BYTE >Rts1	; USER PROVIDES ROUTINE
	.BYTE >Rts1	;
	.BYTE 0,0	; SPACE FOR HACKERS

CLOAL: ; close output lo byte
	.byte <Rts1
	.byte <Rts1
	.byte <Rts1
	.byte 0,0

;-----------------------------------------------------------

ConCur: ; console cursor positioning
	stp ; not supplied yet
		; was = Rts1 in the .bin file

;--- 65816S console I/O ---------------

OutCh: ; output char in A to console
	pha
@loop:	.byte $02,$FE ; cop $FE ; 65816S simulator: get status
	lsr
	lsr
	bcc @loop
	pla
	.byte $02,$fd ; cop $FD ; 65816S simulator: put char
	rts


GetCh: ; Get a single character from the keyboard.
@loop:	.byte $02,$fe ; cop $FE  ; 65816S simulator: get status
	lsr
	bcc @loop
	.byte $02,$fc ; cop $FC ; 65816S simulator: get char
	rts


;kernel_havekey: ; is a console keyboard key waiting?
;	.byte $02,$fe ; cop $FE  ; 65816S simulator: get status
;	and #1
;	jmp PushA


;------------------------------------------------------------------------------
; dynamic memory Starts here

;      FOCEND - TEXT AREAS AND THE LIKE

Prog0: ; Start of stored (grp 0) program text
	.byte 0,0		; LINE NUMBER OF 00.00
	.byte " C FOCAL-65 (V3D) 26-AUG-77",$0D

Prog1: ; Start of user program text
	.byte EOP

Variable0: ; Start of variable space when program is erased

;VEnd:
	.byte EOV	; END OF VARIABLE LIST when program is erased



 .org $5f00 ; end of dynamic RAM
RamLastPage: .res 256  ; PDP stack top page.  can grow below this



 .org $fffa ; CPU vectors
	.word NmiSrv	; NMI
	.word Start	; RESET
	.word IntSrv	; BRK & IRQ  modified  L349e should do this, but it isn't being called


	 .END
